  
/**********************************************************************
Version 
0.01 03.03.09
**********************************************************************/


/*************  Nummerierung der Adressierungsarten  ******************

nr     reg2       segm
    reg1    konst
 1   -   -    -     -   : kein Operand
 2   i   -    -     -   : ri
 3   i   -    k     -   : ri{cpk}
 4   i   -    -     -   : ri{debug}
 5   i   -    -     -   : ri{system}
 6   i   j    -     -   : ri|rj
 7   i   j    k     -   : ri|rj{cpk}
 8   i   -    -     -   : ri[15:0]|ri[31:16]
 9   i   j    -     -   : ri[31:16]|rj[31:16]
10   i   j    -     -   : ri[31:16]|rj[15:0]
11   i   j    -     -   : ri[15:0]|rj[31:16]
12   i   j    -     -   : ri[15:0]|rj[15:0]
26   i   -    -     -   : |ri|
27   i   -    -     -   : ~ri
28   i   -    m     -   : ri*k   k=1,2,4,8 m=ld(k)=0,1,2,3 
29   -   -    -     -   : sp
30   -   -    -     -   : sp{java}
31   i   -    -     -   : ri[31:16]
32   i   -    -     -   : ri[15:8]
33   i   -    -     -   : ri[23:16]
34   i   -    -     -   : ri[31:24]
35   i   -    k     -   : ri<<k   k=0-31
36   i   -    k     -   : ri>>k   k=0-31
37   i   -    -     -   : -(ri)
38   i   -    -     -   : (ri)+
39   i   j    0     -   : (ri,rj) 
39   i   j    m     -   : (ri,rj*k)   k=1,2,4,8 m=ld(k)=0,1,2,3 
40   i   j    -     -   : (ri,rj[7:0]*4)
41   i   j    -     -   : (ri,rj[15:8]*4)
42   i   j    -     -   : (ri,rj[23:16]*4)
43   i   j    -     -   : (ri,rj[31:24]*4)
44   i   0    0     -   : (ri)
44   i   1   off    -   : off.b(ri)
44   i   2   off    -   : off(ri)
45   i   -   off    -   : off(pc)
451  i   -   off    -   : off(sp)
46   i   -   off    -   : off[i]
47   i   -    -     -   : LeadingZeros{ri}
48   i   -    k     -   : ri[k]
49   i   j    k     -   : ri[j:k]
50   -   -    k     -   : sr[k]
51   -   -    -     -   : sr[3:0]
52   -   -    -     -   : sr[CZ]
521  -   -    -     -   : sr[C]
53   1   -   imm32  -   : #imm8
53   2   -   imm32  -   : #imm16
53   3   -   imm32  -   : #imm32

***********************************************************************

dec_operand1(0,p,op)

 i   j   k    m     -   : r15/r14/..../r1/r0{cpi}
 8   j   k    m     -   : r15/r14/..../r1/r0
 9   j   k    m     -   : r15/r14/..../r1/r0{user}

     j=BITMASK(r15/r14/r13/r12/r11/r10/r9/r8/r7/r6/r5/r4/r3/r2/r1/r0)
     k=BITMASK(r15-r14/r13-r12/r11-r10/r9-r8/r7-r6/r5-r4/r3-r2/r1-r0) or 0
     m=BITMASK(r15/r14/r12/r11/r10/r9-r8/r7-r4/r3-r0) or 0


 dec_operand1(1,p,op)

 i   j   k    m     -   : r0/r1/..../r14/r15{cpi}
 8   j   k    m     -   : r0/r1/..../r14/r15
 9   j   k    m     -   : r0/r1/..../r14/r15{user}

     j=BITMASK(r0/r1/r2/r3/r4/r5/r6/r7/r8/r9/r10/r11/r12/r13/r14/r15)
     k=BITMASK(r0-r1/r2-r3/r4-r5/r6-r7/r8-r9/r10-r11/r12-r13/r14-r15) or 0
     m=BITMASK(r0-r3/r4-r7/r8-r9/r10/r11/r12/r14/r15) or 0


**********************************************************************/


/*********************** Linux calls **********************************

       Nr  1.P  2.P  3.P  4.P  5.P  6.P  ret 
x86   eax  ebx  ecx  edx  esi  edi       eax
       r0   r3   r2   r1   r5   r6        r0
       
a32    r8  r12  r11  r10   r9   r5   r3   r12  

**********************************************************************/
  
/**********************************************************************

 Folgende externe Datenstrukturen bzw. Funktionen werden benoetigt;

 FILE
 stdin
 stdout
 fopen()    : Textdatei
 fopenb()   : Binaerdatei: keine Umwandlung  cr lf  <->  lf
 fclose()
 getc()
 putc()
 exit()

 int kann 2 oder 4 Byte gross sein
 long muss 4 Byte gross sein

**********************************************************************/

#define abs(x) (((x) >= 0) ? (x) : (- (x))) 

#include <stdio.h>

#define maxlabel 5000
#define maxbuf 40000
#define max_line_lang 160
#define max_if 10

#define max6        31L
#define min6       -32L
#define max8       127L
#define min8      -128L
#define max9       255L
#define min9      -256L
#define max10      511L
#define min10     -512L
#define max11     1023L
#define min11    -1024L
#define max12     2047L
#define min12    -2048L
#define max16    32767L
#define min16   -32768L
#define max17    65535L
#define min17   -65536L
#define max18   131071L
#define min18  -131072L
#define max21  1048575L
#define min21 -1048576L
#define max22  2097151L
#define min22 -2097152L

#define high3        7L
#define high4       15L
#define high5       31L
#define high6       63L
#define high7      127L
#define high8      255L
#define high9      511L
#define high10    1023L
#define high11    2047L
#define high14   16383L
#define high16   65535L


#define TAB  9
#define EOL 10
#define CR  13
/*define NULL 0*/
#define BS   8



typedef struct {int nr,reg1,reg2; long konst; int segm;} op_typ;

FILE *mac, *lst, *com, *fopen(), *fopenb();

char lab_buf[maxbuf + max_line_lang+5]; /* Labelnamen              */
char *lab_pa[maxlabel+5];               /* Pointer auf Labelnamen  */
long lab_wert[maxlabel+5];              /* Werte der Labels        */
char lab_guelt[maxlabel+5];             /* 0    : Blockmarkierung  */
                                        /* 1/-1 : lokales Label    */
                                        /* 2/-2 : normales Label   */
                                        /* 3/-3 : globales Label   */
                                        /* 4    : @-Label          */
                                        /* negativ: Wert ungueltig */
int lab_block=2;              /* Nummer des letzen Blockbeginns    */
int lab_lokal=2;              /* Nummer des ersten lokalen  Labels */
int lab_last= -1;             /* Nummer des letzen eingetr. Labels */


char last_line[160];
int  l_line_lang=0;

int  if_wert=0;
int  list_level=0;

int  last_ch=0;
int  next_ch;
int  line_nr=1;
int  line_sp=0;
int  op_pref;
int  pass2=0;
int  blk_flag=0;


/*************************************************************/

main()
{
 long li,lj,lk;
 int i,j;
 int op32;
 char *p,*q,*r;
 int par[5];


 char if_stack[max_if+5];
 int  if_level=0;

 char opcode[max_line_lang];
 char operand[max_line_lang];
 char operand2[max_line_lang];

 op_typ  op1,op2,op3;

 char file_name[20];

 print_string("\n  ******************************************************");
 print_string("\n  *                                                    *");
 print_string("\n  *    AAA   DDDD   EEEEE  L       AAA    333    222   *");
 print_string("\n  *   A   A  D   D  E      L      A   A      3  2   2  *");
 print_string("\n  *   AAAAA  D   D  EEEE   L      AAAAA    33      2   *");
 print_string("\n  *   A   A  D   D  E      L      A   A      3    2    *");
 print_string("\n  *   A   A  DDDD   EEEEE  LLLLL  A   A   333   22222  *");
 print_string("\n  *                                                    *");
 print_string("\n  *                                                    *");
 print_string("\n  *                                                    *");
 print_string("\n  *             Version 0.01                           *");
 print_string("\n  *               20.02.09                             *");
 print_string("\n  *                                                    *");
 print_string("\n  *                                                    *");
 print_string("\n  ******************************************************");
 print_string("\n\n");
 print_string("\n\n  Filename (ohne .mac): ");

 i=0;
 p=file_name;
 while (1)
    {*p = getc(stdin);
     if (*p == EOL || *p == CR) break;
     if (i<8) p++,i++;
    }
 *p++ = '.';  *p++ = 'm';  *p++ = 'a';  *p++ = 'c';  *p = 0; 

 mac = fopen(file_name,"r");
 if (mac==NULL) ende(1,31);
 next_ch = getc(mac);


 lab_pa[0]=lab_buf;
 lab_guelt[0]=0;
 ins_lab("@",0L,4);
 ins_lab("@@",0L,4);
 print_string("\n Pass 1\n");

 do
   {
    if (pass2) 
     { /*ini pass 2*/
       fclose(mac);
       last_ch=0;
       mac = fopen(file_name,"r");
       if (mac==NULL) ende(2,31);
       next_ch = getc(mac);
       p=file_name; while (*p++ != '.'); *p++ = 'l'; *p++ = 's'; *p = 't'; 
       lst = fopen(file_name,"w");
       if (lst==NULL) ende(3,32);
       p=file_name; while (*p++ != '.'); *p++ = 'b'; *p++ = 'i'; *p = 'n'; 
       com = fopen(file_name,"wb");

       if (com==NULL) ende(4,33);
       line_nr=1;
       line_sp=0;
       blk_flag=0;
       lab_wert[0]=0;
       lab_wert[1]=0;
       lab_block=2;
       lab_lokal=2;
       if_level=0;
       if_wert=0;
       list_level=0;
       print_string(" Pass 2\n");
     }

    while (get_opcode(opcode))
     {if (cmps(opcode,"if")) goto _if;
      if (cmps(opcode,"else")) goto _else;
      if (cmps(opcode,"endif")) goto _endif;
      if (if_wert < 0) {skip_line(); goto nextline;}

      op32=0;
      switch(opcode[0]) 
       {case  0 : break;
        case '=': {j=2; goto op__;};
        case ':': {j=3; goto op__;};
        case 'a': goto op_a;
        case 'b': goto op_b;
        case 'c': goto op_c;
        case 'd': goto op_d;
        case 'e': goto op_e;
        case 'f': goto op_f;
        case 'g': goto op_g;
        case 'h': goto op_h;
        case 'i': goto op_i;
        case 'j': goto op_j;
        case 'k': goto op_k;
        case 'l': goto op_l;
        case 'm': goto op_m;
        case 'n': goto op_n;
        case 'o': goto op_o;
        case 'p': goto op_p;
        case 'q': goto op_q;
        case 'r': goto op_r;
        case 's': goto op_s;
        case 't': goto op_t;
        case 'u': goto op_u;
        case 'v': goto op_v;
        case 'w': goto op_w;
        case 'x': goto op_x;
        case 'y': goto op_y;
        case 'z': goto op_z;
        default:  ende(5,1);
       }
      nextline: 

      if (op_pref&&if_wert>=0) ende(6,2); 
      read_eol();
     }
    if (if_wert) ende(7,27); 
    pass2=!pass2;
   } while (pass2);

 list_label();
 ende(0,0);

/*************************************************************/

op__:
 p=opcode;
 while (*++p);
 *opcode = *--p;
 *p=0;
 if (opcode[0]=='_') j=1; 
 get_operand(operand);
 i=get_w(operand,&li); 
 if (!i) j = -j;
 ins_lab(opcode,li,j);
 goto nextline;

op_a:
 if (cmps(opcode,"abs.l"))      goto _absl;
 if (cmps(opcode,"add.l"))      goto _addl;
 if (i=cmps_cc(opcode,"add_?.l")) goto _add_ccl;
 if (cmps(opcode,"addc.l"))     goto _addcl;
 if (cmps(opcode,"and.l"))      goto _andl;
 if (i=cmps_cc(opcode,"and_?.l")) goto _and_ccl;
 if (cmps(opcode,"asr.l"))      goto _asrl;
 ende(8,1);

op_b:
 if (i=cmps_cc(opcode,"b?.b"))  goto _bccb;
 if (i=cmps_cc(opcode,"b?.l"))  goto _bccl;
 if (cmps(opcode,"blk.b"))      goto _blkl;
 if (cmps(opcode,"blk.w"))      goto _blkw;
 if (cmps(opcode,"blk.l"))      goto _blkl;
 if (cmps(opcode,"br.l"))       goto _brl;
 if (cmps(opcode,"br.b"))       goto _brw;
 if (cmps(opcode,"br.w"))       goto _brw;
 if (cmps(opcode,"bsr.l"))      goto _bsrl;
 if (cmps(opcode,"bsr.b"))      goto _bsrw;
 if (cmps(opcode,"bsr.w"))      goto _bsrw;
 ende(9,1);

op_c:
 if (cmps(opcode,"cmp.b"))      goto _cmpb;
 if (cmps(opcode,"cmp.l"))      goto _cmpl;
 if (cmps(opcode,"cmpc.l"))     goto _cmpcl;
 if (cmps(opcode,"cmp.w"))      goto _cmpw;
 if (cmps(opcode,"cmpq.l"))     goto _cmpql;
 ende(10,1);

op_d:
 if (cmps(opcode,"dc.b"))       goto _dcb;
 if (cmps(opcode,"dc.l"))       goto _dcl;
 if (cmps(opcode,"dc.w"))       goto _dcw;
 if (cmps(opcode,"divs.l"))     goto _divsl;
 if (cmps(opcode,"divu.l"))     goto _divul;
 ende(11,1);

op_e:
 if (cmps(opcode,"eor.l"))      goto _eorl;
 if (i=cmps_cc(opcode,"eor_?.l")) goto _eor_ccl;
 if (cmps(opcode,"even"))       goto _even;
 if (cmps(opcode,"even4"))      goto _even4;
 if (cmps(opcode,"even16"))     goto _even16;
 if (cmps(opcode,"evencom"))    goto _evencom;
 ende(12,1);

op_f:
 ende(13,1);

op_g:
 ende(14,1);

op_h:
 ende(15,1);

op_i:
 ende(16,1);

op_j:
 if (cmps(opcode,"jsr.l"))      goto _jsrl;
 if (cmps(opcode,"jsr"))        goto _jsrl;
 ende(17,1);

op_k:
 ende(18,1);

op_l:
 if (cmps(opcode,"label_block")) goto _label;
 if (cmps(opcode,"lsl.l"))      goto _lsll;
 if (cmps(opcode,"lsr.l"))      goto _lsrl;
 ende(19,1);

op_m:
 if (cmps(opcode,"move.b"))     goto _moveb;
 if (cmps(opcode,"move.bit"))   goto _movebit;
 if (i=cmps_cc(opcode,"move_?.b")) goto _move_ccb;
 if (cmps(opcode,"move.d"))     goto _moved;
 if (cmps(opcode,"move.l"))     goto _movel;
 if (cmps(opcode,"moveq.l"))    goto _moveql;
 if (i=cmps_cc(opcode,"move_?.l")) goto _move_ccl;
 if (cmps(opcode,"move_lset.l"))   goto _move_lsetl;
 if (cmps(opcode,"move.w"))     goto _movew;
 if (i=cmps_cc(opcode,"move_?.w")) goto _move_ccw;
 if (cmps(opcode,"movem.l"))    goto _moveml;
 if (cmps(opcode,"movem.d"))    goto _movemd;

 if (cmps(opcode,"movs.bl"))    goto _movsbl;
 if (i=cmps_cc(opcode,"movs_?.bl")) goto _movs_ccbl;
 if (cmps(opcode,"movs.wl"))    goto _movswl;
 if (i=cmps_cc(opcode,"movs_?.wl")) goto _movs_ccwl;
 if (cmps(opcode,"movs.l"))     goto _movsl;

 if (cmps(opcode,"movu.bl"))    goto _movubl;
 if (i=cmps_cc(opcode,"movu_?.bl")) goto _movu_ccbl;
 if (cmps(opcode,"movu.wl"))    goto _movuwl;
 if (i=cmps_cc(opcode,"movu_?.wl")) goto _movu_ccwl;
 if (cmps(opcode,"movu.l"))     goto _movul;

 if (cmps(opcode,"mul.l"))      goto _mull;
 ende(20,1);

op_n:
 if (cmps(opcode,"neg.l"))      goto _negl;
 if (cmps(opcode,"nop"))        goto _nop;
 if (cmps(opcode,"not.l"))      goto _notl;
 ende(21,1);

op_o:
 if (cmps(opcode,"or.l"))       goto _orl;
 if (i=cmps_cc(opcode,"or_?.l")) goto _or_ccl;
 ende(22,1);

op_p:
 ende(23,1);

op_q:
 ende(24,1);

op_r:
 if (cmps(opcode,"rocl.l"))     goto _rocll;
 if (cmps(opcode,"rocr.l"))     goto _rocrl;
 if (cmps(opcode,"rtd.l"))      goto _rtdl;
 if (cmps(opcode,"rtd"))        goto _rtdl;
 if (cmps(opcode,"rte.l"))      goto _rtel;
 if (cmps(opcode,"rte"))        goto _rtel;
 if (i=cmps_cc(opcode,"rts_?.l")) goto _rts_ccl;
 if (i=cmps_cc(opcode,"rts_?")) goto _rts_ccl;
 if (cmps(opcode,"rts.l"))      goto _rtsl;
 if (cmps(opcode,"rts"))        goto _rtsl;
 if (cmps(opcode,"rtt.l"))      goto _rttl;
 if (cmps(opcode,"rtt"))        goto _rttl;
 ende(25,1);

op_s:
 if (cmps(opcode,"subc.l"))     goto _subcl;
 if (cmps(opcode,"sub.l"))      goto _subl;
 if (cmps(opcode,"subq.l"))     goto _subql;
 if (i=cmps_cc(opcode,"sub_?.l")) goto _sub_ccl;
 if (i=cmps_cc(opcode,"sub_?_sf.l")) goto _sub_cc_sfl;
 if (i=cmps_cc(opcode,"sub_?_hf.l")) goto _sub_cc_hfl;
 ende(26,1);

op_t:
 if (cmps(opcode,"trap"))       goto _trap;
 if (cmps(opcode,"tst.l"))      goto _tstl;
 ende(27,1);

op_u:
 ende(28,1);

op_v:
 ende(29,1);

op_w:
 ende(30,1);

op_x:
 ende(31,1);

op_y:
 ende(32,1);

op_z:
 ende(33,1);
/*************************************************************/

/*************************************************************/
/*************************************************************/
_if:
 get_operand(operand);
 if (if_level > max_if) ende(34,28);
 if_stack[if_level++] = if_wert;
 if (if_wert<0) {if_wert = -2; goto nextline;}
 if (! get_w(operand,&li)) ende(35,10);
 if (li) if_wert = 1; else if_wert = -1;
 goto nextline;

_else:
 if (if_wert ==  1 || if_wert ==  -2) {if_wert = -3; goto nextline;}
 if (if_wert == -1)                   {if_wert =  2; goto nextline;}
 ende(36,29);

_endif:
 if (!if_level) ende (11,30);
 if_wert = if_stack[--if_level];
 goto nextline;
/*************************************************************/
/*************************************************************/

/*************************************************************/
_absl:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr == 2)                  /* abs.l  ri  */
   {aus_word(0x5c40+op1.reg1);
    goto nextline;
   }
 ende(37,3);

/*************************************************************/
_addl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==1)      /* add.l  ri,rj  */
   {aus_word(0x0000+(op1.reg1<<9)+op2.reg1);
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)      /* add.l  ri,rj,rk  */
   {aus_long(0xe0000000+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==26 && op2.nr==2 && op3.nr==2)       /* add.l  |ri|,rj,rk  */
   {aus_long(0xe0000e40+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==28 && op2.nr==2 && op3.nr==2)      /* add.l  ri*k,rj,rn  */
   {aus_long(0xe0000000+(op1.reg1<<16)+(op1.konst<<4)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

ende(38,3);

/*************************************************************/
_add_ccl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)      /* add_cc.l  ri,rj,rk  */
   {aus_long(0xe1d0e000+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+((i-1)<<8));
    goto nextline;
   }

 ende(39,3);

/*************************************************************/
_addcl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)      /* addc.l  ri,rj,rk  */
   {aus_long(0xe0000040+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2 && op3.nr==1)     /* addc.l  #0,ri  */
   {if (pass2 && op1.konst!=0) ende(40,3);
    aus_word(0x5c00+op2.reg1);
    goto nextline;
   }

 ende(41,3);

/*************************************************************/
_andl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==1)     /* and.l  ri,rj  */
   {aus_word(0x0060+(op1.reg1<<9)+op2.reg1);
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)     /* and.l  ri,rj,rk  */
   {aus_long(0xe1e00000+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==35 && op2.nr==2 && op3.nr==2)     /* and.l  ri<<imm5u,rj,rk  */
   {aus_long(0xe1e00000+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+(op1.konst<<4));
    goto nextline;
   }

 if (op1.nr==36 && op2.nr==2 && op3.nr==2)    /* and.l  ri>>imm5u,rj,rk  */
   {aus_long(0xe1e00200+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+(op1.konst<<4));
    goto nextline;
   }

 if (op1.nr==27 && op2.nr==2 && op3.nr==1)     /* and.l  ~ri,rj  */
   {aus_word(0x0080+(op1.reg1<<9)+op2.reg1);
    goto nextline;
   }

                                                /* and.l  #$0000xxxx,ri  */
                                                /* and.l  #$ffffxxxx,ri  */
                                                /* and.l  #$xxxx0000,ri  */
 if (op1.nr==53 && op2.nr==2 && op3.nr==1)      /* and.l  #$xxxxffff,ri  */
   {if (pass2){if      ((op1.konst|0x0000ffff) == 0xffffffff) i=0;
               else if ((op1.konst&0xffff0000) == 0x00000000) i=1;
               else if ((op1.konst|0xffff0000) == 0xffffffff) i=2;
               else if ((op1.konst&0x0000ffff) == 0x00000000) i=3;
               else ende(42,3);
              }
    if (i<2) aus_long(0xe0100000+(op2.reg1<<16)+(i<<25)+ (op1.konst & 0x0000ffff) );
       else  aus_long(0xe0100000+(op2.reg1<<16)+(i<<25)+ (((unsigned long) op1.konst)>>16));
    goto nextline;
   }


 ende(43,3);

/*************************************************************/
_and_ccl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)     /* and_cc.l  ri,rj,rk  */
   {aus_long(0xe1d0e020+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+((i-1)<<8));
    goto nextline;
   }

 ende(44,3);

/*************************************************************/
_asrl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)     /* asr.l  ri,rj,rk  */
   {aus_long(0xe0000840+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2 && op3.nr==1)     /* asr.l  #imm5u,ri  */
   {if (pass2 && ((unsigned long) op1.konst > high5)) ende(45,3);
    aus_word(0xa140+((op1.konst&0x1e)<<8)+((op1.konst&0x1)<<4)+op2.reg1);
    goto nextline;
   }
 if (op1.nr==53 && op2.nr==2 && op3.nr==2)     /* asr.l  #imm5u,ri,rj  */
   {if (pass2 && ((unsigned long) op1.konst > high5)) ende(46,3);
    aus_long(0xe0001400+(op1.konst&0x1f)+(op2.reg1<<25)+(op3.reg1<<16));
    goto nextline;
   }


 ende(47,3);

/*************************************************************/

/*===========================================================*/

_bccb:                                 /* bcc.b  label */
 if (i>8) ende (51,6);
 get_operand(operand);
 get_wert(operand,&li);
 li -= *lab_wert;
 if (pass2 && (li > max9 || li < min9)) ende(48,6);
 aus_word(0xc000+(i-1)+((li&0x1fe)<<3));
 goto nextline;

/*-----------------------------------------------------------*/
_brl:                                  /* br.l  label */
 i=16;
_bccl:                                 /* bcc.l  label */
 get_operand(operand);
 get_wert(operand,&li);
 li -= *lab_wert;
 if (pass2 && (li > max22 || li < min22)) ende(49,6);
 aus_long(0xe0800000+((i-1)<<16)+ ((li&0x3c0000)<<7) + ((li&0x20000)<<3) + ((li&0x1fffe)>>1));
 goto nextline;


/*-----------------------------------------------------------*/
_brw:                                 /* br.w  label */
 get_operand(operand);
 get_wert(operand,&li);
 li -= *lab_wert;
 if (pass2 && (li > max11 || li < min11) ) ende(50,6);
 aus_word(0xc008+ ((li&0x1fe)<<3) + ((li&0x600)>>9) ); 
 goto nextline;

/*************************************************************/

_bsrl:                                 /* bsr.l  label */
 get_operand(operand);
 get_wert(operand,&li);
 li -= *lab_wert;
 if (pass2 && (li > max22 || li < min22)) ende(51,6);
 aus_long(0xe0a00000 + ((li&0x3c0000)<<7) + ((li&0x20000)<<3) + ((li&0x1fffe)>>1));
 goto nextline;


/*-----------------------------------------------------------*/
_bsrw:                                 /* bsr.w  label */
 get_operand(operand);
 get_wert(operand,&li);
 li -= *lab_wert;
 if (pass2 && (li > max11 || li < min11) ) ende(52,6);
 aus_word(0xc00c+ ((li&0x1fe)<<3) + ((li&0x600)>>9) ); 
 goto nextline;


/*************************************************************/
_blkb:
 get_operand(operand);
 if (! get_w(operand,&li)) ende(53,10);
 get_operand(operand);
 if (! *operand) {*lab_wert += li; blk_flag=1; goto nextline;}
 if (get_wert(operand,&lj) != 1) ende(54,4);
 i=12;
 for (;li>0;li--)  aus_byte((int)lj);
 goto nextline;
 

_blkl:
 get_operand(operand);
 if (! get_w(operand,&li)) ende(55,10);
 get_operand(operand);
 if (! *operand) {*lab_wert += li*4; blk_flag=1; goto nextline;}
 get_wert(operand,&lj);
 for (;li>0;li--)  aus_long(lj);
 goto nextline;


_blkw:
 get_operand(operand);
 if (! get_w(operand,&li)) ende(56,10);
 get_operand(operand);
 if (! *operand) {*lab_wert += li*2; blk_flag=1; goto nextline;}
 if (get_wert(operand,&lj) > 2) ende(57,4);
 for (;li>0;li--)  aus_word((int)lj);
 goto nextline;


/*************************************************************/


/*************************************************************/
_cmpb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 if (op1.nr==2 && op2.nr==2)          /* cmp.b  ri,rj */
   {aus_long(0xe0001800+(op1.reg1<<24)+(op2.reg1<<16));
    goto nextline;
   }

 ende(58,3);

/*************************************************************/
_cmpl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 


 if (op1.nr==2 && op2.nr==2)          /* cmp.l  ri,rj */
   {aus_word(0x0030+(op1.reg1<<9)+op2.reg1);
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2)          /* cmp.l  #imm21s, ri */
   {if (pass2 && (op1.konst > max21 || op1.konst<min21)) ende(59,3);
    aus_long(0xe0400000+(op2.reg1<<16)+ ((op1.konst&0x1e0000)<<8) 
              + ((op1.konst&0x10000)<<4)+ (op1.konst&0xffff)   );
    goto nextline;
   }

 ende(60,3);

/*************************************************************/
_cmpcl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==2)       /* cmpc.l   ri, rj  */
   {aus_long(0xe0001300+(op1.reg1<<25)+(op2.reg1<<16));
    goto nextline;
   }

 if (op1.nr==53&& op2.nr==2)      /* cmpc.l   #0,ri  */
   {if (pass2 && op1.konst!=0) ende(61,3);
    aus_word(0x5c20+op2.reg1);
    goto nextline;
   }

 

/*************************************************************/
_cmpql:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==53 && op2.nr==2)          /* cmpq.l  #imm6s, ri */
   {if (pass2 && (op1.konst > max6 || op1.konst<min6)) ende(62,3);
    aus_word(0x5800+op2.reg1 + ((op1.konst&0x3f)<<4));
    goto nextline;
   }

 ende(63,3);

/*************************************************************/
_cmpw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==2)          /* cmp.w  ri,rj */
   {aus_long(0xe0001900+(op1.reg1<<24)+(op2.reg1<<16));
    goto nextline;
   }

 ende(64,3);

/*************************************************************/

/*************************************************************/
_dcb:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;

   if ( (i = *operand) == '\'' || i == '"')
      {q=operand+1;
       while (*q != i) if (! *q++) ende(65,25);
       if (! *++q)
          {q=operand+1;
           while (*q != i) aus_byte(*q++);
           continue;
          }
      }
   if (get_wert(operand,&li) != 1) ende(66,4);
   aus_byte((int)li);
  }

_dcbw:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;

   if ( (i = *operand) == '\'' || i == '"')
      {q=operand+1;
       while (*q != i) if (! *q++) ende(67,25);
       if (! *++q)
          {q=operand+1;
           while (*q != i) {aus_byte(*q++); aus_byte(0);}
           continue;
          }
      }
   if (get_wert(operand,&li) != 1) ende(68,4);
   aus_byte((int)li); aus_byte(0);
  }

_dcl:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   get_wert(operand,&li);
   aus_long(li);
  }

_dcw:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   if (get_wert(operand,&li) > 2) ende(69,4);
       aus_word((int)li);
  }

_dcl_:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   get_wert(operand,&li);
   li=(li>>24) + ((li>>8)&0xff00) +((li<<8)&0xff0000) +(li<<24);
   aus_long(li);
  }

_dcw_:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   if (get_wert(operand,&li) > 2) ende(70,4);
   li=((li>>8)&0x00ff) +(li<<8);
       aus_word((int)li);
  }

/*************************************************************/
_divsl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==6)   /*  divs.l  ri, rj, rn|rm  */
   {if ( (op3.reg1 != op3.reg2+1) || (op3.reg2 & 0x01)) ende(71,3);
    aus_long(0xe0000c00+(op1.reg1<<16)+(op2.reg1<<25)+(op3.reg2));
    goto nextline;
   }


 ende(72,3);

/*************************************************************/
_divul:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==6)   /*  divu.l  ri, rj, rn|rm  */
   {if ( (op3.reg1 != op3.reg2+1) || (op3.reg2 & 0x01)) ende(73,3);
    aus_long(0xe0000d00+(op1.reg1<<16)+(op2.reg1<<25)+(op3.reg2));
    goto nextline;
   }

 ende(74,3);


/*************************************************************/
_eorl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==1)   /*  eor.l   ri, rj  */
   {aus_word(0x0050+(op1.reg1<<9)+op2.reg1);
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)   /*  eor.l   ri, rj, rk  */
   {aus_long(0xe1e02000+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==35 && op2.nr==2 && op3.nr==2)   /*  eor.l   ri<<imm5u, rj, rk  */
   {aus_long(0xe1e02000+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+(op1.konst<<4));
    goto nextline;
   }

 if (op1.nr==36 && op2.nr==2 && op3.nr==2)   /*  eor.l   ri>>imm5u, rj, rk  */
   {aus_long(0xe1e02200+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+(op1.konst<<4));
    goto nextline;
   }
                                             /*  eor.l   #$0000xxxx, ri  */
 if (op1.nr==53 && op2.nr==2 && op3.nr==1)   /*  eor.l   #$xxxx0000, ri  */
   {if (!pass2 || (op1.konst&0xffff0000) == 0x00000000)
       {aus_long(0xec100000+(op2.reg1<<16)+ (op1.konst & 0x0000ffff) ); goto nextline;}

    if ((op1.konst&0x0000ffff) == 0x00000000)
       {aus_long(0xee100000+(op2.reg1<<16)+ (((unsigned long) op1.konst)>>16)); goto nextline;}

    ende(75,3);
   }

 ende(76,3);

/*************************************************************/
_eor_ccl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)   /*  eor_cc.l   ri, rj, rk  */
   {aus_long(0xe1d0e040+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+((i-1)<<8));
    goto nextline;
   }

 ende(77,3);


/*************************************************************/
_even:
 li=2; lj=0;
 get_operand(operand);
 if (*operand) 
    {if (! get_w(operand,&li)) ende(78,10);
     get_operand(operand);
     if (*operand) if (get_wert(operand,&lj) != 1) ende (501,4);
    }
 if (lk = *lab_wert%li) for (;lk<li;lk++) aus_byte((int)lj);
 goto nextline;
  
_even4:
 i = ( *lab_wert & (long) 0x03 );
 if (i) i = 4-i;
 while (i--) aus_byte(0x00);
 goto nextline;

_even16:
 i = ( *lab_wert & (long) 0x0f );
 if (i) i = 16-i;
 while (i--) aus_byte(0x00);
 goto nextline;

_evencom:
 li=2; lj=0;
 get_operand(operand);
 if (*operand) 
    {if (! get_w(operand,&li)) ende(79,10);
     get_operand(operand);
     if (*operand) if (get_wert(operand,&lj) != 1) ende (501,4);
    }
 if (lk = lab_wert[1]%li) for (;lk<li;lk++) aus_byte((int)lj);
 goto nextline;


/*************************************************************/
_jsrl:
 get_operand(operand);

 i=0; while (operand[i++]); i-=2;
 if (i<=0 || operand[0] != '(' || operand[i] != ')' ) ende(80,3);
 operand[i] = 0;

 dec_operand(operand+1,&op1); 

 if (op1.nr == 2)                 /*  jsr.l   (ri)  */
   {aus_word(0x5d10 + op1.reg1);
    goto nextline;
   }

 if (op1.nr == 44)                 /*  jsr.l   (disp18s(ri))  */
   {if (pass2 && (op1.konst > max18 || op1.konst < min18 || (op1.konst&0x03))) ende(81,6);
    aus_long(0xf0100000 + (op1.reg1<<16) + ((op1.konst&0x3ffff)>>2) );
    goto nextline;
   }

 ende(82,3);


/*************************************************************/
_list:
 list_level++;
 goto nextline;

/*************************************************************/
/*************************************************************/
_label:
 if (!pass2)
     {++lab_last;
      if (lab_last > maxlabel) ende(83,24);
      lab_block=lab_last+1;
      lab_pa[lab_block]=lab_pa[lab_last];
      lab_guelt[lab_block]=0;
     }
     else
     {lab_block=lab_lokal;
      while (lab_guelt[lab_block++]);
     }
 goto nextline;



/*************************************************************/
_lsll:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)   /*  lsl.l   ri,rj,rk  */
   {aus_long(0xe0000940+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2 && op3.nr==1)   /*  lsl.l   #imm5u, ri  */
   {if (pass2 && ((unsigned long)op1.konst)>high5) ende(84,3);
    aus_word(0xa160+op2.reg1+((op1.konst&0x1e)<<8)+((op1.konst&0x01)<<4));
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2 && op3.nr==2)   /*  lsl.l   #imm5u, ri, rj  */
   {if (pass2 && ((unsigned long)op1.konst)>high5) ende(85,3);
    aus_long(0xe0001500 + (op2.reg1<<25) + (op3.reg1<<16) + op1.konst);
    goto nextline;
   }

 ende(86,3);

/*************************************************************/

/*************************************************************/
_lsrl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)  /*  lsl.l   ri,rj,rk  */
   {aus_long(0xe0000a40+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2 && op3.nr==1)   /*  lsl.l   #imm5u, ri  */
   {if (pass2 && ((unsigned long)op1.konst)>high5) ende(87,3);
    aus_word(0xa180+op2.reg1+((op1.konst&0x1e)<<8)+((op1.konst&0x01)<<4));
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2 && op3.nr==2)   /*  lsl.l   #imm5u, ri, rj  */
   {if (pass2 && ((unsigned long)op1.konst)>high5) ende(88,3);
    aus_long(0xe0001600 + (op2.reg1<<25) + (op3.reg1<<16) + op1.konst);
    goto nextline;
   }
 ende(89,3);

/*************************************************************/
_moveb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 


 if (op1.nr==44 && op2.nr==2)        /*  move.b   disp12s(ri), rj  */
   {if (pass2 && (op1.konst > max12 || op1.konst<min12)) ende(90,3);
    aus_long(0xe1d04000 + (op1.reg1<<25) + (op2.reg1<<16) + (op1.konst&0xfff));
    goto nextline;
   }

 if (op1.nr==44 && op2.nr==32)        /*  move.b   disp12s(ri), rj[15:8]  */
   {if (pass2 && (op1.konst > max12 || op1.konst<min12)) ende(91,3);
    aus_long(0xe1d05000 + (op1.reg1<<25) + (op2.reg1<<16) + (op1.konst&0xfff));
    goto nextline;
   }

 if (op1.nr==44 && op2.nr==33)        /*  move.b   disp12s(ri), rj[23:16]  */
   {if (pass2 && (op1.konst > max12 || op1.konst<min12)) ende(92,3);
    aus_long(0xe1d06000 + (op1.reg1<<25) + (op2.reg1<<16) + (op1.konst&0xfff));
    goto nextline;
   }

 if (op1.nr==44 && op2.nr==34)        /*  move.b   disp12s(ri), rj[31:24]  */
   {if (pass2 && (op1.konst > max12 || op1.konst<min12)) ende(93,3);
    aus_long(0xe1d07000 + (op1.reg1<<25) + (op2.reg1<<16) + (op1.konst&0xfff));
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==37)        /*  move.b   ri, -(rj)  */
   {aus_word(0x00f0 + op1.reg1 + (op2.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==38)        /*  move.b   ri, (rj)+  */
   {aus_word(0x00c0 + op1.reg1 + (op2.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==39)        /*  move.b   ri, ri, (rj,rk*n)  */
   {aus_long(0xe0000b00 + op1.reg1 + (op2.reg1<<25) + (op2.reg2<<16) + (op2.konst<<4) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==44)
                                      /*  move.b   ri, (rj)  */
   {if (op2.reg2<2)                   /*  move.b   ri, disp3u.b(rj)  */
        {if (pass2 && ((unsigned long)op2.konst)>7) ende(94,3);
         aus_word(0xa080 + op1.reg1 + (op2.reg1<<9) + (op2.konst<<4) );
         goto nextline;
        }
                                      /*  move.b   ri, disp16s(rj)  */
    if (pass2 && (op1.konst > max16 || op1.konst<min16)) ende(95,3);
    aus_long(0xe1600000 + (op1.reg1<<16) + (op2.reg1<<25) + (op2.konst&0xffff) );
    goto nextline;
   }

 ende(96,3);

/*************************************************************/
_movebit:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

                                                    /*  move.bit #0, adr17s[n] */
 if (op1.nr==53 && op2.nr==46)                      /*  move.bit #1, adr17s[n] */
   {if (pass2 && (  (((unsigned long)op1.konst) > 1 ) 
                  || op2.konst>max17 || op2.konst<min17 || (op2.konst&0x03)) ) ende(97,3);
    if (op1.konst==0) 
       {aus_long(0xf6100000 + (op2.reg1<<15) + ((op2.konst&0xffff)>>2)); goto nextline;}
    aus_long(0xf8100000 + (op2.reg1<<15) + ((op2.konst&0xffff)>>2));
    goto nextline;
   }
                                                    /*  move.bit #0, ri[n] */
 if (op1.nr==53 && op2.nr==48)                      /*  move.bit #1, ri[n] */
   {if (pass2 &&  ((unsigned long)op1.konst)>1  ) ende(98,3);
    if (op1.konst==0) 
       {aus_word(0xa1c0+op2.reg1+((op2.konst&0x1e)<<8)+((op2.konst&0x01)<<4)); goto nextline;}
    aus_word(0xa1a0+op2.reg1+((op2.konst&0x1e)<<8)+((op2.konst&0x01)<<4));
    goto nextline;
   }

                                                    /*  move.bit #0, sr[n] */
 if (op1.nr==53 && op2.nr==50)                      /*  move.bit #1, sr[n] */
   {if (pass2 &&  ((unsigned long)op1.konst)>1  ) ende(99,3);
    if (op1.konst==0) 
       {aus_word(0xd403+op2.reg1+(op2.konst<<4)); goto nextline;}
    aus_word(0xd203+op2.reg1+(op2.konst<<4));
    goto nextline;
   }

 if (op1.nr==49 && op2.nr==51)                      /*  move.bit ri[3:0], sr[3:0] */
   {if (pass2 && (op1.konst!=0 || op1.reg2!=3)) ende(100,2);
    aus_word(0x5d30+op1.reg1);
    goto nextline;
   }

 if (op1.nr==49 && op2.nr==49)                      /* move.bit  ri[n:0], rj[m:k] */
   {if (pass2 && (op1.konst!=0 || op1.reg2!=(op2.reg2-op2.konst))) ende(101,2);
    aus_long(0xe1d0d000+(op1.reg1<<16)+(op2.reg1<<25)+(op1.konst<<5)+(op1.reg2+1));
    goto nextline;
   }

 if (op1.nr==48 && op2.nr==52)                      /*  move.bit ri[n], sr[CZ] */
   {aus_long(0xedb00000+(op1.reg1<<16) + op1.konst);
    goto nextline;
   }

 if (op1.nr==521 && op2.nr==48)                    /*  move.bit sr[C], ri[n]  */
   {aus_long(0xefb00000+(op2.reg1<<16) + op2.konst);
    goto nextline;
   }

 if (op1.nr==50 && op2.nr==52)                      /*  move.bit sr[n], sr[CZ] */
   {aus_word(0xd003+(op1.konst<<4));
    goto nextline;
   }

 ende(102,3);

/*************************************************************/
_moved:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op2.nr==6 && op1.nr==37)                          /* move.d   -(ri), rn|rm */
   {if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01)) ende(103,3);
    aus_word(0xa110 + op2.reg2 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op2.nr==6 && op1.nr==38)                          /* move.d   (ri)+, rn|rm */
   {if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01)) ende(104,3);
    aus_word(0xa101 + op2.reg2 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op2.nr==6 && op1.nr==44 && op1.reg2==0)          /* move.d    (ri), rn|rm */
   {if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01)) ende(105,3);
    aus_word(0xa100 + op2.reg2 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op2.nr==6 && op1.nr==44)                        /* move.d disp16s(ri), rn|rm */
   {if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01)) ende(106,3);
    if (pass2 && (op1.konst > max16 || op1.konst<min16)) ende(107,3);
    aus_long(0xe0e10000 + (op2.reg2<<16) + (op1.reg1<<25) + (op2.konst & 0xffff));
    goto nextline;
   }

 if (op2.nr==6 && op1.nr==39)                        /* move.d  (ri,rj*k), rn|rm */
   {if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01)) ende(108,3);
    aus_long(0xe0000200 + op2.reg2 + (op1.reg1<<25) + (op1.reg2<<16) + (op1.konst<<4) );
    goto nextline;
   }

 if (op1.nr==6 && op2.nr==37)                       /* move.d  rn|rm, -(ri) */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01)) ende(109,3);
    aus_word(0xa121 + op1.reg2 + (op2.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==6 && op2.nr==38)                       /* move.d  rn|rm, (ri)+ */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01)) ende(110,3);
    aus_word(0xa120 + op1.reg2 + (op2.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==6 && op2.nr==44 && op2.reg2==0)        /* move.d  rn|rm, (ri) */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01)) ende(111,3);
    aus_word(0xa111 + op1.reg2 + (op2.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==6 && op2.nr==44)                      /* move.d rn|rm, disp16s(ri) */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01)) ende(112,3);
    if (pass2 && (op2.konst > max16 || op2.konst<min16)) ende(113,3);
    aus_long(0xe0e10000 + (op1.reg2<<16) + (op2.reg1<<25) + (op2.konst & 0xffff));
    goto nextline;
   }

 if (op1.nr==6 && op2.nr==39)                     /* move.d rn|rm, (ri,rj*k) */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01)) ende(114,3);
    aus_long(0xe0000800 + op1.reg2 + (op2.reg1<<25) + (op2.reg2<<16) + (op2.konst<<4) );
    goto nextline;
   }


 if (op2.nr==7 && op1.nr==37)                     /* move.d   -(ri), rn|rm{cpj} */
   {if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01) ) ende(115,3);
    aus_long(0xefa00050 + (op1.reg1<<16) + (op2.konst<<13) + (op2.reg2<<8) );
    goto nextline;
   }

 if (op2.nr==7 && op1.nr==39)                     /* move.d  (ri,rj*k), rn|rm {cpj} */
   {if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01)  ) ende(116,3);
    aus_long(0xefa01040+(op1.reg1<<16)+op1.reg2+(op2.konst<<13)+(op2.reg2<<8)+(op1.konst<<4));
    goto nextline;
   }

                                                  /* move.d   disp14u(ri), rn|rm {cp0} */
 if (op2.nr==7 && op1.nr==44)                     /* move.d   disp10u(ri), rn|rm {cpj} */
   {if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01) ) ende(117,3);
    if (pass2 && (op1.konst & 0x03)) ende(118,3);
    if (op2.konst==0)
       {if (pass2 && ((unsigned long)op1.konst)>high14) ende(119,3);
        aus_long(0xf3a00000 + (op1.reg1<<16) + ((op1.konst&0x3c00)<<2) + (op2.reg2<<8) 
                            + (op1.konst&0x3ff>>2) );
        goto nextline;
       }
    if (pass2 && ((unsigned long)op1.konst)>high10) ende(120,3);
    aus_long(0xe9a01000 + (op1.reg1<<16) + (op2.konst<<13) + (op2.reg2<<8) 
                            + (op1.konst&0x3ff>>2) );
    goto nextline;
   }

 if (op1.nr==7 && op2.nr==6)                     /* move.d  ri|rj {cpk}, rn|rm */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01) ) ende(121,3);
    if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01)) ende(122,3);
    aus_long(0xefa00010 + (op2.reg2<<16) + (op1.reg2<<8) + (op1.konst<<13) );
    goto nextline;
   }

                                                  /* move.d   rn|rm {cp0}, disp14u(ri) */
 if (op1.nr==7 && op2.nr==44)                     /* move.d   rn|rm {cpj}, disp10u(ri) */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01) ) ende(123,3);
    if (pass2 && (op2.konst & 0x03)) ende(124,3);
    if (op1.konst==0)
       {if (pass2 && ((unsigned long)op2.konst)>high14) ende(125,3);
        aus_long(0xf7a00000 + (op2.reg1<<16) + ((op2.konst&0x3c00)<<2) + (op1.reg2<<8) 
                            + (op2.konst&0x3ff>>2) );
        goto nextline;
       }
    if (pass2 && ((unsigned long)op2.konst)>high10) ende(126,3);
    aus_long(0xeba01000 + (op2.reg1<<16) + (op1.konst<<13) + (op1.reg2<<8) 
                            + (op2.konst&0x3ff>>2) );
    goto nextline;
   }

 if (op1.nr==7 && op2.nr==38)                     /* move.d   rn|rm {cpj}, (ri)+ */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01) ) ende(127,3);
    aus_long(0xefa00070 + (op2.reg1<<16) + (op1.konst<<13) + (op1.reg2<<8) );
    goto nextline;
   }

 if (op1.nr==7 && op2.nr==39)                     /* move.d  rn|rm {cpj}, (ri,rj*k) */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01)) ende(128,3);
    aus_long(0xefa010c0+(op2.reg1<<16)+op2.reg2+(op1.konst<<13)+(op1.reg2<<8)+(op2.konst<<4));
    goto nextline;
   }

 if (op1.nr==6 && op2.nr==7)                     /* move.d  rn|rm, ri|rj {cpk} */
   {if ( (op1.reg1 != op1.reg2+1) || (op1.reg2 & 0x01) ) ende(129,3);
    if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01) ) ende(130,3);
    aus_long(0xefa00030 + (op1.reg2<<16) + (op2.reg2<<8) + (op2.konst<<13) );
    goto nextline;
   }

 ende(131,3);

/*************************************************************/
_movel:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op2.nr==2 && op1.nr==37)                          /* move.l   -(ri), rj */
   {aus_word(0x0140 + op2.reg1 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op2.nr==2 && op1.nr==38)                          /* move.l   (ri)+, rj */
   {aus_word(0x0100 + op2.reg1 + (op1.reg1<<9) );
    goto nextline;
   }
                                                      /* move.l    (ri), rj */
 if (op2.nr==2 && op1.nr==44 && op1.reg2<2)           /* move.l    disp7u.b(ri), rj */
   {if (pass2 && ((((unsigned long)op1.konst) > high7) || (op1.konst&0x3)) ) ende(132,3);
    aus_word(0x6000 + op2.reg1 + (op1.reg1<<9) + ((op1.konst&0x7f)<<2) );
    goto nextline;
   }

 if (op2.nr==2 && op1.nr==44)                        /* move.l disp16s(ri), rj */
   {if (pass2 && (op1.konst > max16 || op1.konst<min16)) ende(133,3);
    aus_long(0xe0f00000 + (op2.reg1<<16) + (op1.reg1<<25) + (op1.konst & 0xffff));
    goto nextline;
   }

 if (op2.nr==2 && op1.nr==39)                        /* move.l  (ri,rj*k), rn */
   {aus_long(0xe0000300 + op2.reg1 + (op1.reg1<<25) + (op1.reg2<<16) + (op1.konst<<4) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==37)                       /* move.l  rj, -(ri) */
   {aus_word(0x00d0 + op1.reg1 + (op2.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==38)                       /* move.l  rj, (ri)+ */
   {aus_word(0x00a0 + op1.reg1 + (op2.reg1<<9) );
    goto nextline;
   }

                                                     /* move.l  rj, (ri)       */
 if (op1.nr==2 && op2.nr==44 && op2.reg2<2)          /* move.l  rj, disp6u(ri) */
   {if (pass2 && ((((unsigned long)op2.konst) > high6) || (op2.konst&0x3)) ) ende(134,3);
    aus_word(0x8100 + op1.reg1 + (op2.reg1<<9) + ((op2.konst&0x7f)<<2) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==44)                      /* move.l rj, disp16s(ri) */
   {if (pass2 && (op2.konst > max16 || op2.konst<min16)) ende(135,3);
    aus_long(0xe1400000 + (op1.reg1<<16) + (op2.reg1<<25) + (op2.konst & 0xffff));
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==39)                     /* move.l rn, (ri,rj*k) */
   {aus_long(0xe0000900 + op1.reg1 + (op2.reg1<<25) + (op2.reg2<<16) + (op2.konst<<4) );
    goto nextline;
   }


 if (op2.nr==3 && op1.nr==37)                     /* move.l   -(ri), rm{cpj} */
   {aus_long(0xefa00040 + (op1.reg1<<16) + (op2.konst<<13) + (op2.reg1<<8) );
    goto nextline;
   }

 if (op2.nr==3 && op1.nr==39)                     /* move.l  (ri,rj*k), rm {cpj} */
   {if ( (op2.reg1 != op2.reg2+1) || (op2.reg2 & 0x01)) ende(136,3);
    aus_long(0xefa01000+(op1.reg1<<16)+op1.reg2+(op2.konst<<13)+(op2.reg1<<8)+(op1.konst<<4));
    goto nextline;
   }

                                                  /* move.l   disp14u(ri), rm {cp0} */
 if (op2.nr==3 && op1.nr==44)                     /* move.l   disp10u(ri), rm {cpj} */
   {if (pass2 && (op1.konst & 0x03)) ende(137,3);
    if (op2.konst==0)
       {if (pass2 && ((unsigned long)op1.konst)>high14) ende(138,3);
        aus_long(0xf1a00000 + (op1.reg1<<16) + ((op1.konst&0x3c00)<<2) + (op2.reg1<<8) 
                            + (op1.konst&0x3ff>>2) );
        goto nextline;
       }
    if (pass2 && ((unsigned long)op1.konst)>high10) ende(139,3);
    aus_long(0xe9a00000 + (op1.reg1<<16) + (op2.konst<<13) + (op2.reg1<<8) 
                            + (op1.konst&0x3ff>>2) );
    goto nextline;
   }

 if (op1.nr==3 && op2.nr==2)                     /* move.l  rj{cpk}, rm */
   {aus_long(0xefa00000 + (op2.reg1<<16) + (op1.reg1<<8) + (op1.konst<<13) );
    goto nextline;
   }

                                                  /* move.l   rm {cp0}, disp14u(ri) */
 if (op1.nr==3 && op2.nr==44)                     /* move.l   rm {cpj}, disp10u(ri) */
   {if (pass2 && (op2.konst & 0x03)) ende(140,3);
    if (op1.konst==0)
       {if (pass2 && ((unsigned long)op2.konst)>high14) ende(141,3);
        aus_long(0xf5a00000 + (op2.reg1<<16) + ((op2.konst&0x3c00)<<2) + (op1.reg1<<8) 
                            + (op2.konst&0x3ff>>2) );
        goto nextline;
       }
    if (pass2 && ((unsigned long)op2.konst)>high10) ende(142,3);
    aus_long(0xeba00000 + (op2.reg1<<16) + (op1.konst<<13) + (op1.reg1<<8) 
                            + (op2.konst&0x3ff>>2) );
    goto nextline;
   }

 if (op1.nr==3 && op2.nr==38)                     /* move.l   rm {cpj}, (ri)+ */
   {aus_long(0xefa00060 + (op2.reg1<<16) + (op1.konst<<13) + (op1.reg1<<8) );
    goto nextline;
   }

 if (op1.nr==3 && op2.nr==39)                     /* move.l  rm {cpj}, (ri,rj*k) */
   {aus_long(0xefa01080+(op2.reg1<<16)+op2.reg2+(op1.konst<<13)+(op1.reg1<<8)+(op2.konst<<4));
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==3)                     /* move.l  rm, rj {cpk} */
   {aus_long(0xefa00020 + (op1.reg1<<16) + (op2.reg1<<8) + (op2.konst<<13) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==2)                     /* move.l  ri, rj  */
   {aus_word(0x0090 + (op1.reg1<<9) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2)                      /* move.l #imm21s, ri */
   {if (pass2 && (op1.konst > max21 || op1.konst<min21)) ende(143,3);
    aus_long(0xe0600000 + (op2.reg1<<16) + ((op1.konst&0x1e0000)<<8) 
                                         + ((op1.konst&0x010000)<<4) + (op1.konst & 0xffff));
    goto nextline;
   }

 if (op1.nr==40 && op2.nr==2)                     /* move.l  (ri,rj[7:0]*4), rn  */
   {aus_long(0xe0000f80 + (op1.reg1<<25) + (op1.reg2<<16) + op2.reg1 );
    goto nextline;
   }
 if (op1.nr==41 && op2.nr==2)                     /* move.l  (ri,rj[15:8]*4), rn  */
   {aus_long(0xe0000f90 + (op1.reg1<<25) + (op1.reg2<<16) + op2.reg1 );
    goto nextline;
   }
 if (op1.nr==42 && op2.nr==2)                     /* move.l  (ri,rj[23:16]*4), rn  */
   {aus_long(0xe0000fa0 + (op1.reg1<<25) + (op1.reg2<<16) + op2.reg1 );
    goto nextline;
   }
 if (op1.nr==43 && op2.nr==2)                     /* move.l  (ri,rj[31:24]*4), rn  */
   {aus_long(0xe0000fb0 + (op1.reg1<<25) + (op1.reg2<<16) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==12 && op2.nr==39)                     /* move.l  ri[15:0]|rj[15:0], (rn,rm*k)  */
   {aus_long(0xe1e08000 + (op1.reg1<<25) + (op1.reg2<<16) + (op2.reg2<<8) + (op2.konst<<4) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==11 && op2.nr==39)                     /* move.l  ri[15:0]|rj[31:16], (rn,rm*k)  */
   {aus_long(0xe1e09000 + (op1.reg1<<25) + (op1.reg2<<16) + (op2.reg2<<8) + (op2.konst<<4) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==10 && op2.nr==39)                     /* move.l  ri[31:16]|rj[15:0], (rn,rm*k)  */
   {aus_long(0xe1e0a000 + (op1.reg1<<25) + (op1.reg2<<16) + (op2.reg2<<8) + (op2.konst<<4) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==9 && op2.nr==39)                     /* move.l  ri[31:16]|rj[31:16], (rn,rm*k)  */
   {aus_long(0xe1e0b000 + (op1.reg1<<25) + (op1.reg2<<16) + (op2.reg2<<8) + (op2.konst<<4) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==12 && op2.nr==44)                     /* move.l  ri[15:0]|rj[15:0], disp10u(rk)  */
   {if (pass2 && ( (((unsigned long)op2.konst) > high10) || (op2.konst&0x3)) ) ende(144,3);
    aus_long(0xe1e0c000 + (op1.reg1<<25) + (op1.reg2<<16) +  (op2.konst<<2) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==11 && op2.nr==44)                     /* move.l  ri[15:0]|rj[31:16], disp10u(rk)  */
   {if (pass2 && ( (((unsigned long)op2.konst) > high10) || (op2.konst&0x3)) ) ende(145,3);
    aus_long(0xe1e0d000 + (op1.reg1<<25) + (op1.reg2<<16) +  (op2.konst<<2) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==10 && op2.nr==44)                     /* move.l  ri[31:16]|rj[15:0], disp10u(rk)  */
   {if (pass2 && ( (((unsigned long)op2.konst) > high10) || (op2.konst&0x3)) ) ende(146,3);
    aus_long(0xe1e0e000 + (op1.reg1<<25) + (op1.reg2<<16) +  (op2.konst<<2) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==9 && op2.nr==44)                     /* move.l  ri[31:16]|rj[31:16], disp10u(rk)  */
   {if (pass2 && ( (((unsigned long)op2.konst) > high10) || (op2.konst&0x3)) ) ende(147,3);
    aus_long(0xe1e0f000 + (op1.reg1<<25) + (op1.reg2<<16) +  (op2.konst<<2) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==45 && op2.nr==2)                     /* move.l  disp9u(pc), ri  */
   {li = op1.konst - (*lab_wert & 0xfffffffc);
    if (pass2 && ( (((unsigned long)li) > high9) || (op1.konst&0x3)) ) ende(148,3);
    aus_word(0xe4800 +  (li<<2) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==451 && op2.nr==2)                    /* move.l  disp9u(sp), ri  */
   {if (pass2 && ( (((unsigned long)op1.konst) > high9) || (op1.konst&0x3)) ) ende(149,3);
    aus_word(0xe4000 +  (op1.konst<<2) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==451)                    /* move.l  ri, disp9u(sp)  */
   {if (pass2 && ( (((unsigned long)op2.konst) > high9) || (op2.konst&0x3)) ) ende(150,3);
    aus_word(0xe5000 +  (op2.konst<<2) + op1.reg1 );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==4)                    /* move.l  ri, rj{debug}  */
   {aus_long(0xe7b00000  +  (op1.reg1<<16) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==5)                    /* move.l  ri, rj{system}  */
   {aus_long(0xe3b00000  +  (op1.reg1<<16) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==4 && op2.nr==2)                    /* move.l  ri{debug}, rj  */
   {aus_long(0xe5b00000  +  (op2.reg1<<16) + op1.reg1 );
    goto nextline;
   }

 if (op1.nr==5 && op2.nr==2)                    /* move.l  ri{system}, rj  */
   {aus_long(0xe1b00000  +  (op2.reg1<<16) + op1.reg1 );
    goto nextline;
   }

 if (op1.nr==47 && op2.nr==2)                    /* move.l  LeadingZeros{ri}, rj  */
   {aus_long(0xe0001200  +  (op1.reg1<<25) + (op2.reg1<<16) );
    goto nextline;
   }



 ende(151,3);

/*************************************************************/
_moveql:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==53 && op2.nr==2)                      /* move.l #imm8s, ri */
   {if (pass2 && (op1.konst > max8 || op1.konst<min8)) ende(152,3);
    aus_word(0x3000 + op2.reg1 + ((op1.konst&0xff)<<4));
    goto nextline;
   }

 ende(153,3);

/*************************************************************/
_movew:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==53 && op2.nr==31)                      /* move.w #imm16, ri[31:16] */
   {if (pass2 && (op1.reg1 > 2)) ende(154,3);
    aus_long(0xfc10000 + (op2.reg1<<16) + (op1.konst & 0xffff));
    goto nextline;
   }

 if (op1.nr==44 && op2.nr==2)                        /* move.w disp12s(ri), rj */
   {if (pass2 && (op1.konst > max12 || op1.konst<min12)) ende(155,3);
    aus_long(0xe1d00000 + (op2.reg1<<16) + (op1.reg1<<25) + (op2.konst & 0xfff));
    goto nextline;
   }

 if (op1.nr==44 && op2.nr==31)                        /* move.w disp12s(ri), rj[31:16] */
   {if (pass2 && (op1.konst > max12 || op1.konst<min12)) ende(156,3);
    aus_long(0xe1d01000 + (op2.reg1<<16) + (op1.reg1<<25) + (op2.konst & 0xfff));
    goto nextline;
   }



 if (op1.nr==2 && op2.nr==37)                       /* move.w  rj, -(ri) */
   {aus_word(0x00e0 + op1.reg1 + (op2.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==38)                       /* move.w  rj, (ri)+ */
   {aus_word(0x00b0 + op1.reg1 + (op2.reg1<<9) );
    goto nextline;
   }

                                                     /* move.w  rj, (ri)       */
 if (op1.nr==2 && op2.nr==44 && op2.reg2<2)          /* move.w  rj, disp4u(ri) */
   {if (pass2 && ((((unsigned long)op2.konst) > high4) || (op2.konst&0x1)) ) ende(157,3);
    aus_word(0xa000 + op1.reg1 + (op2.reg1<<9) + (op2.konst<<3) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==44)                      /* move.w rj, disp16s(ri) */
   {if (pass2 && (op2.konst > max16 || op2.konst<min16)) ende(158,3);
    aus_long(0xe1500000 + (op1.reg1<<16) + (op2.reg1<<25) + (op2.konst & 0xffff));
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==39)                     /* move.w rn, (ri,rj*k) */
   {aus_long(0xe0000a00 + op1.reg1 + (op2.reg1<<25) + (op2.reg2<<16) + (op2.konst<<4) );
    goto nextline;
   }

 ende(159,3);

/*************************************************************/
_move_ccb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==44)           /* move_cc.b     ri, disp9u(rj) */
   {if (pass2 && ((((unsigned long)op2.konst) > high9)) ) ende(160,3);
    aus_long(0xe1f00e00 + (op1.reg1<<16) + (op2.reg1<<25) + op2.konst + ((i-1)<<12));
    goto nextline;
   }
 ende(161,3);

/*************************************************************/
_move_ccl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==44)           /* move_cc.l     ri, disp11u(rj) */
   {if (pass2 && ((((unsigned long)op2.konst) > high11 || (op2.konst&0x03))) ) ende(162,3);
    aus_long(0xe1f00a00 + (op1.reg1<<16) + (op2.reg1<<25) + (op2.konst<2) + ((i-1)<12));
    goto nextline;
   }

 if (op1.nr==44 && op2.nr==2)           /* move_cc.l     disp11u(ri),rj  */
   {if (pass2 && ((((unsigned long)op1.konst) > high11 || (op1.konst&0x03))) ) ende(153,3);
    aus_long(0xe1f00000 + (op2.reg1<<16) + (op1.reg1<<25) + (op1.konst<2));
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==2)           /* move_cc.l     ri,rj  */
   {aus_long(0xe0001700 + (op2.reg1<<16) + (op1.reg1<<25) + ((i-1)<4));
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2)      /* move_ccl   #imm8s,ri */
   {if (pass2 && (op1.konst > max8 || op1.konst<min8)) ende(164,3);
    aus_long(0xf9b00000+(op2.reg1<<16)+(op1.konst&0xff)+((i-1)<<8) );
    goto nextline;
   }

 ende(165,3);

/*************************************************************/
_move_lsetl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 
 if (op1.nr==2 && op2.nr==44)           /* move_lset.l     ri, disp16s(rj)) */
   {if (pass2 && (op2.konst > max16 || op2.konst<min16)) ende(166,3);
    aus_long(0xe1700000 + (op1.reg1<<16) + (op2.reg1<<25) + (op2.konst & 0xffff));
    goto nextline;
   }

 ende(167,3);

/*************************************************************/
_move_ccw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==44)           /* move_cc.w     ri, disp10u(rj) */
   {if (pass2 && ((((unsigned long)op2.konst) > high10 || (op2.konst&0x01))) ) ende(168,3);
    aus_long(0xe1f00c00 + (op1.reg1<<16) + (op2.reg1<<25) + (op2.konst<1) + ((i-1)<12));
    goto nextline;
   }
 ende(169,3);

/*************************************************************/
_movsbl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==2)                     /* movs.bl  ri, ri  */
   {if (op1.reg1 != op2.reg1) ende(170,3);
    aus_word(0x5c60 + op1.reg1 );
    goto nextline;
   }

 if (op1.nr==39 && op2.nr==2)                     /* movs.bl  (ri,rj*k), rn  */
   {aus_long(0xe0000600 + op2.reg1 + (op1.reg1<<25) + (op1.reg2<<16) + (op1.konst<<4) );
    goto nextline;
   }
 if (op1.nr==44 && op2.nr==2)                        /* movs.bl disp16s(ri), rj */
   {if (pass2 && (op1.konst > max16 || op1.konst<min16)) ende(171,3);
    aus_long(0xe1200000 + (op2.reg1<<16) + (op1.reg1<<25) + (op1.konst & 0xffff));
    goto nextline;
   }

 ende(172,3);

/*************************************************************/
_movs_ccbl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==44 && op2.nr==2)                        /* movs_cc.bl disp9u(ri), rj */
   {if (pass2 && (((unsigned long)op1.konst) > high9) )ende(173,3);
    aus_long(0xe1f00600 + (op2.reg1<<16) + (op1.reg1<<25) + ((i-1)<<13) + (op1.konst & 0x1ff));
    goto nextline;
   }

 ende(174,3);

/*************************************************************/
_movswl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==2)                     /* movs.wl  ri, ri  */
   {if (op1.reg1 != op2.reg1) ende(175,3);
    aus_word(0x5c80 + op1.reg1 );
    goto nextline;
   }

 if (op1.nr==37 && op2.nr==2)                     /* movs.wl  -(ri), rj  */
   {aus_word(0x0150 + op2.reg1 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==38 && op2.nr==2)                     /* movs.wl  (ri)+, rj  */
   {aus_word(0x0110 + op2.reg1 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==39 && op2.nr==2)                     /* movs.wl  (ri,rj*k), rn  */
   {aus_long(0xe0000400 + op2.reg1 + (op1.reg1<<25) + (op1.reg2<<16) + (op1.konst<<4) );
    goto nextline;
   }

                                                      /* movs.wl    (ri), rj */
 if (op1.nr==44 && op1.reg2<2 && op2.nr==2)           /* movs.wl    disp4u.b(ri), rj */
   {if (pass2 && ((((unsigned long)op1.konst) > high4) || (op1.konst&0x1)) ) ende(176,3);
    aus_word(0x8000 + op2.reg1 + (op1.reg1<<9) + ((op1.konst&0x0f)<<3) );
    goto nextline;
   }

 if (op1.nr==44 && op2.nr==2)                        /* movs.wl disp16s(ri), rj */
   {if (pass2 && (op1.konst > max16 || op1.konst<min16)) ende(177,3);
    aus_long(0xe1000000 + (op2.reg1<<16) + (op1.reg1<<25) + (op1.konst & 0xffff));
    goto nextline;
   }

 ende(178,3);

/*************************************************************/
_movs_ccwl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==44 && op2.nr==2)                        /* movs_cc.wl disp10u(ri), rj */
   {if (pass2 && (((unsigned long)op1.konst) > high10)) ende(179,3);
    aus_long(0xe1f00200 + (op2.reg1<<16) + (op1.reg1<<25) + ((i-1)<<12) + (op1.konst>>1));
    goto nextline;
   }

 ende(180,3);

/*************************************************************/
_movsl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==49 && op2.nr==2)                        /* movs.l  ri[n:m], rj */
   {aus_long(0xe1d0b000+(op1.reg1<<16)+(op2.reg1<<25)+(op1.konst<<5)+(op1.reg2-op1.konst+1));
    goto nextline;
   }

 ende(181,3);

/*************************************************************/
_movubl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==2)                     /* movu.bl  ri, ri  */
   {if (op1.reg1 != op2.reg1) ende(182,3);
    aus_word(0x5c50 + op1.reg1 );
    goto nextline;
   }

 if (op1.nr==37 && op2.nr==2)                     /* movu.bl  -(ri), rj  */
   {aus_word(0x0170 + op2.reg1 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==38 && op2.nr==2)                     /* movu.bl  (ri)+, rj  */
   {aus_word(0x0130 + op2.reg1 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==39 && op2.nr==2)                     /* movu.bl  (ri,rj*k), rn  */
   {aus_long(0xe0000700 + op2.reg1 + (op1.reg1<<25) + (op1.reg2<<16) + (op1.konst<<4) );
    goto nextline;
   }

                                                      /* movu.bl    (ri), rj */
 if (op1.nr==44 && op1.reg2<2 && op2.nr==2)           /* movu.bl    disp3u.b(ri), rj */
   {if (pass2 && (((unsigned long)op1.konst) > high3)  ) ende(183,3);
    aus_word(0x1800 + op2.reg1 + (op1.reg1<<9) + (op1.konst<<4) );
    goto nextline;
   }

 if (op1.nr==44 && op2.nr==2)                        /* movu.bl disp16s(ri), rj */
   {if (pass2 && (op1.konst > max16 || op1.konst<min16)) ende(184,3);
    aus_long(0xe1300000 + (op2.reg1<<16) + (op1.reg1<<25) + (op1.konst & 0xffff));
    goto nextline;
   }

 ende(185,3);

/*************************************************************/
_movu_ccbl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==44 && op2.nr==2)                        /* movu_cc.bl disp9u(ri), rj */
   {if (pass2 && (((unsigned long)op1.konst) > high9)) ende(186,3);
    aus_long(0xe1f00800 + (op2.reg1<<16) + (op1.reg1<<25) + ((i-1)<<12) + op1.konst);
    goto nextline;
   }

 ende(187,3);

/*************************************************************/
_movuwl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==2)                     /* movu.wl  ri, ri  */
   {if (op1.reg1 != op2.reg1) ende(188,3);
    aus_word(0x5c70 + op1.reg1 );
    goto nextline;
   }

 if (op1.nr==37 && op2.nr==2)                     /* movu.wl  -(ri), rj  */
   {aus_word(0x0160 + op2.reg1 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==38 && op2.nr==2)                     /* movu.wl  (ri)+, rj  */
   {aus_word(0x0120 + op2.reg1 + (op1.reg1<<9) );
    goto nextline;
   }

 if (op1.nr==39 && op2.nr==2)                     /* movu.wl  (ri,rj*k), rn  */
   {aus_long(0xe0000500 + op2.reg1 + (op1.reg1<<25) + (op1.reg2<<16) + (op1.konst<<4) );
    goto nextline;
   }

                                                      /* movu.wl    (ri), rj */
 if (op1.nr==44 && op1.reg2<2 && op2.nr==2)           /* movu.wl    disp4u.b(ri), rj */
   {if (pass2 && ((((unsigned long)op1.konst) > high4) || (op1.konst&0x1)) ) ende(189,3);
    aus_word(0x8080 + op2.reg1 + (op1.reg1<<9) + ((op1.konst&0x0f)<<3) );
    goto nextline;
   }

 if (op1.nr==44 && op2.nr==2)                        /* movu.wl disp16s(ri), rj */
   {if (pass2 && (op1.konst > max16 || op1.konst<min16)) ende(190,3);
    aus_long(0xe1100000 + (op2.reg1<<16) + (op1.reg1<<25) + (op1.konst & 0xffff));
    goto nextline;
   }

 ende(191,3);

/*************************************************************/
_movul:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==49 && op2.nr==2)                        /* movu.l  ri[n:m], rj */
   {aus_long(0xe1d0c000+(op1.reg1<<16)+(op2.reg1<<25)+(op1.konst<<5)+(op1.reg2-op1.konst+1));
    goto nextline;
   }

 if (op1.nr==51 && op2.nr==2)                        /* movu.l  sr[3:0], ri */
   {aus_word(0x5d20+op2.reg1);
    goto nextline;
   }

 ende(192,3);


/*************************************************************/
_movu_ccwl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==44 && op2.nr==2)                        /* movu_cc.wl disp10u(ri), rj */
   {if (pass2 && (((unsigned long)op1.konst) > high10)) ende(193,3);
    aus_long(0xe1f00400 + (op2.reg1<<16) + (op1.reg1<<25) + ((i-1)<<12) + (op1.konst>>1));
    goto nextline;
   }

 ende(194,3);


/*************************************************************/
_moveml:
 get_operand(operand);

                                   /* movem.l (sp)+, R15/r11/r10/r9-r8/r7-r4/r3-r0, r12=0   */
                                   /* movem.l (sp)+, R15/r11/r10/r9-r8/r7-r4/r3-r0, r12=1   */
                                   /* movem.l (sp)+, R15/r11/r10/r9-r8/r7-r4/r3-r0, r12=-1  */
 if ( cmps ( operand , "(sp)+"))   /* movem.l (sp)+, r15/r14/r12/r11/r10/r9-r8/r7-r4/r3-r0  */
    { get_operand(operand);
      dec_operand1(0,operand,&op1); 
      if (op1.nr!=8 || op1.reg2==0) ende (195,4);
      get_operand(operand);
      if (*operand) {if ((op1.reg2&0x80)==0 || (op1.reg2&0x60) ) ende (196,2);
                     if (cmps(operand,"r12=0"))  {aus_word(0xd00a + (op1.reg2<<4)); goto nextline;}
                     if (cmps(operand,"r12=1"))  {aus_word(0xd20a + (op1.reg2<<4)); goto nextline;}
                     if (cmps(operand,"r12=-1")) {aus_word(0xd40a + (op1.reg2<<4)); goto nextline;}
                     ende(197,3);
                    }
      aus_word(0xd002 + (op1.reg2<<4));
      goto nextline;
    }

                                                 /* movem.l         (ri)+, r15/r14/.../r0   i!=15 */
                                                 /* movem.l        (r13)+, R15/r11/.../r0, r12=0  */
                                                 /* movem.l        (r13)+, R15/r11/.../r0, r12=1  */
                                                 /* movem.l        (r13)+, R15/r11/.../r0, r12=-1 */
                                                 /* movem.l         (ri)+, r15/r14/.../r0 {user}  */
                                                 /* movem.l         (ri)+, r7/r6/...../r0 {cpj}   */
 if ( finds ( operand , "(r?)+" , par, &r) )     /* movem.l         (ri)+, r15/r14/.../r8 {cpj}   */
    {if (r!=operand || par[0]>15) ende (198,3);
     get_operand(operand);
     dec_operand1(0,operand,&op1); 
     if (op1.nr>8) {aus_long(0xe7c00000 + (par[0]<<16) + op1.reg1); goto nextline;}
     if (op1.nr<8) {if ((op1.reg1 & 0xff00)==0)
                       {aus_long(0xeda01000 + (par[0]<<16) + (op1.nr<<13) + op1.reg1); goto nextline;}
                    if ((op1.reg1 & 0x00ff)==0)
                       {aus_long(0xeda01100 + (par[0]<<16) + (op1.nr<<13) + (op1.reg1>>8)); goto nextline;}
                    ende(199,3);
                   }
     if (par[0]==15) ende(1991,3);
     get_operand(operand);
     if (par[0]!=13 || *operand==0) {aus_long(0xe3c00000 + (par[0]<<16) + op1.reg1); goto nextline;}

     if ((op1.reg1&0x8000)==0 || (op1.reg1&0x7000) ) ende (196,2);
     if (cmps(operand,"r12=0"))  {aus_long(0xe3cd8000 + op1.reg1); goto nextline;}
     if (cmps(operand,"r12=1"))  {aus_long(0xe3cd9000 + op1.reg1); goto nextline;}
     if (cmps(operand,"r12=-1")) {aus_long(0xe3cdc000 + op1.reg1); goto nextline;}
     ende(197,3);

    }

                                                 /* movem.l         (ri), r15/r14/.../r0   i!=15 */
                                                 /* movem.l        (r13), R15/r11/.../r0, r12=0  */
                                                 /* movem.l        (r13), R15/r11/.../r0, r12=1  */
                                                 /* movem.l        (r13), R15/r11/.../r0, r12=-1 */
                                                 /* movem.l         (ri), r15/r14/.../r0 {user}  */
                                                 /* movem.l         (ri), r7/r6/...../r0 {cpj}   */
 if ( finds ( operand , "(r?)" , par, &r) )      /* movem.l         (ri), r15/r14/.../r8 {cpj}   */
    {if (r!=operand || par[0]>15) ende(200,3);
     get_operand(operand);
     dec_operand1(0,operand,&op1); 
     if (op1.nr>8) {aus_long(0xe5c00000 + (par[0]<<16) + op1.reg1); goto nextline;}
     if (op1.nr<8) {if ((op1.reg1 & 0xff00)==0)
                       {aus_long(0xeda00000 + (par[0]<<16) + (op1.nr<<13) + op1.reg1); goto nextline;}
                    if ((op1.reg1 & 0x00ff)==0)
                       {aus_long(0xeda00100 + (par[0]<<16) + (op1.nr<<13) + (op1.reg1>>8)); goto nextline;}
                    ende(199,3);
                   }
     if (par[0]==15) ende(1991,3);
     get_operand(operand);
     if (*operand==0) {aus_long(0xe1c00000 + (par[0]<<16) + op1.reg1); goto nextline;}

     if (par[0]!=13) ende(1992,3);
     if ((op1.reg1&0x8000)==0 || (op1.reg1&0x7000) ) ende (196,2);
     if (cmps(operand,"r12=0"))  {aus_long(0xe1cd8000 + op1.reg1); goto nextline;}
     if (cmps(operand,"r12=1"))  {aus_long(0xe1cd9000 + op1.reg1); goto nextline;}
     if (cmps(operand,"r12=-1")) {aus_long(0xe1cdc000 + op1.reg1); goto nextline;}
     ende(197,3);

    }


 get_operand(operand2);

 if ( cmps ( operand2 , "-(sp)"))          /* movem.l  r0-r3/r4-r7/r8-r9/r10/r11/r12/r14/r15, -(sp) */
    { dec_operand1(1,operand,&op1);
      if (op1.nr!=8 || op1.reg2==0) ende(202,12);
      aus_word(0xd001 + (op1.reg2<<4));
      goto nextline;
    }
                                                /* movem.l         r0/r1/.../r14/r15,       -(ri)  */
                                                /* movem.l         r0/r1/.../r14/r15{user}, -(ri)  */
                                                /* movem.l         r0/r1/.../r7 {cpj},      -(ri)  */ 
 if ( finds ( operand2 , "-(r?)" , par, &r) )    /* movem.l         r8/r9/.../r15 {cpj},     -(ri)  */
    {if (r!=operand2 || par[0]>15) ende(203,3);
     dec_operand1(1,operand,&op1);
     if (op1.nr>=8) {aus_long(0xebc00000 + ((op1.nr&1)<<26) + (par[0]<<16) + op1.reg1); goto nextline;}
     if ((op1.reg1 & 0xff00)==0){aus_long(0xeda01200 + (par[0]<<16) + (op1.nr<<13) + op1.reg1); goto nextline;}
     if ((op1.reg1 & 0x00ff)==0){aus_long(0xeda01300 + (par[0]<<16) + (op1.nr<<13) + (op1.reg1>>8)); 
                                 goto nextline;}
     ende(204,3);
    }
 
                                                /* movem.l         r15/r14/.../r0,        (ri)  */
                                                /* movem.l         r15/r14/.../r0 {user}, (ri)  */
                                                /* movem.l         r7/r6/...../r0 {cpj},  (ri)  */ 
 if ( finds ( operand2 , "(r?)" , par, &r) )     /* movem.l         r15/r14/.../r8 {cpj},  (ri)  */
    {if (r!=operand2 || par[0]>15) ende(205,3);
     dec_operand1(0,operand,&op1);
     if (op1.nr>=8) {aus_long(0xe9c00000 + ((op1.nr&1)<<26) + (par[0]<<16) + op1.reg1); goto nextline;}
     if ((op1.reg1 & 0xff00)==0){aus_long(0xeda00200 + (par[0]<<16) + (op1.nr<<13) + op1.reg1); goto nextline;}
     if ((op1.reg1 & 0x00ff)==0){aus_long(0xeda00300 + (par[0]<<16) + (op1.nr<<13) + (op1.reg1>>8)); 
                                 goto nextline;}
     ende(206,3);
    }
  
 ende(207,3);

/*************************************************************/
_movemd:
 get_operand(operand);

 if ( finds ( operand , "(r?)+" , par, &r) )  /* movem.d  (ri)+, r15-r14/r13-r12/..../r1-r0 {cpj} */
    {if (r!=operand || par[0]>15) ende(208,3);
     get_operand(operand);
     dec_operand1(0,operand,&op1); 
     if (op1.nr>7 || op1.konst==0) ende(209,2);
     aus_long(0xeda01400 + (par[0]<<16)  + (op1.nr<<13) + op1.konst); 
     goto nextline;
    }

 if ( finds ( operand , "(r?)" , par, &r) )  /* movem.d  (ri), r15-r14/r13-r12/..../r1-r0 {cpj} */
    {if (r!=operand || par[0]>15) ende(210,3);
     get_operand(operand);
     dec_operand1(0,operand,&op1); 
     if (op1.nr>7 || op1.konst==0) ende(211,2);
     aus_long(0xeda00400 + (par[0]<<16)  + (op1.nr<<13) + op1.konst); 
     goto nextline;
    }

 
 get_operand(operand2);

 if ( finds ( operand2 , "-(r?)" , par, &r) ) /* movem.d  r0-r1/r2-r3/..../r14-r15 {cpj}, -(ri) */
    {if (r!=operand2 || par[0]>15) ende(212,3);
     dec_operand1(1,operand,&op1); 
     if (op1.nr>7 || op1.konst==0) ende(213,2);
     aus_long(0xeda01500 + (par[0]<<16)  + (op1.nr<<13) + op1.konst); 
     goto nextline;
    }
 
 if ( finds ( operand2 , "(r?)" , par, &r) )  /* movem.d  r15-r14/r13-r12/..../r1-r0 {cpj}, (ri) */
    {if (r!=operand2 || par[0]>15) ende(214,3);
     dec_operand1(0,operand,&op1); 
     if (op1.nr>7 || op1.konst==0) ende(215,2);
     aus_long(0xeda00500 + (par[0]<<16)  + (op1.nr<<13) + op1.konst); 
     goto nextline;
    }
  
 ende(216,3);



/*************************************************************/
_mull:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==1)                 /* mul.l           ri, rj */
   {aus_word(0xa130 + (op1.reg1<<9) + op2.reg1 );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)                 /* mul.l           ri, rj, rk */
   {aus_long(0xe0000240 + (op1.reg1<<16) + (op2.reg1<<25) + op3.reg1);
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2 && op3.nr==2)                 /* mul.l        #imm8s, rj, rk */
   {if (pass2 && (op2.konst > max8 || op2.konst<min8)) ende(217,3);
    aus_long(0xe0001000 + (op2.reg1<<16) + (op3.reg1<<25) + (op1.konst&0xff));
    goto nextline;
   }

 ende(218,3);



/*************************************************************/
_negl:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr==2)                 /* neg.l      ri */
   {aus_word(0x5c30 + op1.reg1);
    goto nextline;
   }

 ende(219,3);

/*************************************************************/
_nolist:
 list_level--;
 goto nextline;

/*************************************************************/
_nop:
 aus_word(0xd703);
 goto nextline;

/*************************************************************/
_notl:
 get_operand(operand);
 dec_operand(operand,&op1); 


 if (op1.nr==2)                 /* not.l      ri */
   {aus_word(0x5cd0 + op1.reg1);
    goto nextline;
   }

 ende(220,3);

/*************************************************************/
_odd:
 if (!( *lab_wert & (long) 1) ) aus_byte(0x00);
 goto nextline;

/*************************************************************/
_orl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==1)     /* or.l    ri, rj */
   {aus_word(0x0040+(op1.reg1<<9)+op2.reg1);
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)    /* or.l    ri, rj, rk */
   {aus_long(0xe1e01000+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==35 && op2.nr==2 && op3.nr==2)   /* or.l    ri<<imm5u, rj, rk */
   {aus_long(0xe1e01000+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+(op1.konst<<4));
    goto nextline;
   }

 if (op1.nr==36 && op2.nr==2 && op3.nr==2)   /* or.l    ri>>imm5u, rj, rk */
   {aus_long(0xe1e01200+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+(op1.konst<<4));
    goto nextline;
   }

                                             /* or.l    #$0000xxxx, ri */
 if (op1.nr==53 && op2.nr==2 && op3.nr==1)   /* or.l    #$xxxx0000, ri */
   {if (!pass2 || (op1.konst&0xffff0000) == 0x00000000)
       {aus_long(0xe8100000+(op2.reg1<<16)+ (op1.konst & 0x0000ffff) ); goto nextline;}

    if ((op1.konst&0x0000ffff) == 0x00000000)
       {aus_long(0xea100000+(op2.reg1<<16)+ (((unsigned long) op1.konst)>>16)); goto nextline;}

    ende(221,3);
   }

 ende(222,3);



/*************************************************************/
_or_ccl:                            
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)            /* or_cc.l         ri, rj, rk  */
   {aus_long(0xe1d0e030+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+((i-1)<<8));
    goto nextline;
   }

 ende(223,3);



/*************************************************************/
_rocll: 
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr==2)                /* rocl.l      ri */
   {aus_word(0x5cf0 + op1.reg1);
    goto nextline;
   }

 ende(224,3);

/*************************************************************/
_rocrl: 
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr==2)                /* rocr.l      ri */
   {aus_word(0x5d00 + op1.reg1);
    goto nextline;
   }


 ende(225,3);




/*************************************************************/
_rtel:
 aus_word(0xd603);
 goto nextline;

/*************************************************************/
_rtdl:
 aus_word(0xd623);
 goto nextline;

/*************************************************************/
_rtsl:
 i=16;
_rts_ccl:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr==2 && op1.reg1<13)
   {aus_word(0x5e00 + op1.reg1 +((i-1)<<4) );
    goto nextline;
   }

 if (op1.nr==53)
   {if (!pass2 && op1.konst!=0 && op1.konst!=1 && op1.konst!=-1) ende(226,2);
    if      (op1.konst == 0)  aus_word(0x5e0d + ((i-1)<<4) );
    else if (op1.konst == -1) aus_word(0x5e0e + ((i-1)<<4) );
    else                      aus_word(0x5e0f + ((i-1)<<4) );
    goto nextline;
   }

 ende(227,3);


/*************************************************************/
_rttl:
 aus_word(0xd613);
 goto nextline;

/*************************************************************/
_subcl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)       /* subc.l   ri, rj, rk  */
   {aus_long(0xe0000140+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==53&& op2.nr==2 && op3.nr==1)  /* subc.l   #0,ri  */
   {if (pass2 && op1.konst!=0) ende(228,3);
    aus_word(0x5c10+op2.reg1);
    goto nextline;
   }

 

/*************************************************************/
_subl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==1)        /* sub.l   ri, rj  */
   {aus_word(0x0001+(op1.reg1<<9)+op2.reg1);
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==2 && op3.nr==2 && op1.reg1==op3.reg1)      /* sub.l   ri, rj, ri */
   {aus_word(0x0020+(op2.reg1<<9)+op1.reg1);
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)        /* sub.l   ri, rj, rk */
   {aus_long(0xe0000100+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==28 && op2.nr==2 && op3.nr==2)       /* sub.l   ri*k, rj, rk */
   {aus_long(0xe0000100+(op1.reg1<<16)+(op1.konst<<4)+(op2.reg1<<25)+op3.reg1);
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2 && op3.nr==1)       /* sub.l   #imm21s,ri */
   {if (pass2 && (op1.konst > max21 || op1.konst<min21)) ende(229,3);
    aus_long(0xe0200000+(op2.reg1<<16)+((op1.konst&0x1e0000)<<8)
                                      +((op1.konst&0x010000)<<4)+(op1.konst&0xffff) );
    goto nextline;
   }

 if (op1.nr==53 && op2.nr==2 && op3.nr==2)       /* sub.l   #imm16s,ri,rj */
   {if (pass2 && (op1.konst > max16 || op1.konst<min16)) ende(230,3);
    aus_long(0xe0c00000+(op2.reg1<<25)+(op3.reg1<<16)+(op1.konst&0xffff) );
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==53 && op3.nr==2)       /* sub.l   ri,#imm8s,rj */
   {if (pass2 && (op2.konst > max8 || op2.konst<min8)) ende(231,3);
    aus_long(0xe0001100+(op1.reg1<<25)+(op3.reg1<<16)+(op2.konst&0xff) );
    goto nextline;
   }



ende(232,3);

/*************************************************************/
_subql:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==53 && op2.nr==2 &&op2.reg1!=13)      /* subq.l   #imm8s,ri */
   {if (pass2 && (op1.konst > max8 || op1.konst<min8)) ende(233,3);
    aus_word(0x2000+op2.reg1+((op1.konst&0xff)<<4));
    goto nextline;
   }

 if (op1.nr==53 && ((op2.nr==2 && op2.reg1==13) || op2.nr==29)  )    /* subq.l   #imm10s,sp */
   {if (pass2 && (op1.konst > max10 || op1.konst<min10 || (op1.konst&0x3))) ende(234,3);
    aus_word(0x2000+op2.reg1+((op1.konst&0x3ff)<<2));
    goto nextline;
   }

 ende(235,3);

/*************************************************************/
_sub_ccl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr==2 && op2.nr==2 && op3.nr==2)         /* sub_cc.l   ri, rj, ri */
   {aus_long(0xe1d0e010+(op1.reg1<<16)+(op2.reg1<<25)+op3.reg1+((i-1)<<8));
    goto nextline;
   }

 if (op1.nr==2 && op2.nr==53 && op3.nr==2 && op1.reg1==op3.reg1)   /* sub_cc.l   ri,#imm8s,ri */
   {if (pass2 && (op2.konst > max8 || op2.konst<min8)) ende(236,3);
    aus_long(0xfbb00000+(op1.reg1<<16)+(op2.konst&0xff)+((i-1)<<8) );
    goto nextline;
   }
 if (op1.nr==53 && op2.nr==2 && op3.nr==1)      /* sub_cc.l   #imm8s,ri */
   {if (pass2 && (op1.konst > max8 || op1.konst<min8)) ende(237,3);
    aus_long(0xf7b00000+(op2.reg1<<16)+(op1.konst&0xff)+((i-1)<<8) );
    goto nextline;
   }

 ende(238,3);


/*************************************************************/
_sub_cc_sfl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==53 && op2.nr==2)      /* sub_cc_sf.l   #imm8s,ri */
   {if (pass2 && (op1.konst > max8 || op1.konst<min8)) ende(239,3);
    aus_long(0xf7b00000+(op2.reg1<<16)+(op1.konst&0xff)+((i-1)<<8) );
    goto nextline;
   }

 ende(240,3);


/*************************************************************/
_sub_cc_hfl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==53 && op2.nr==2)      /* sub_cc_sf.l   #imm8s,ri */
   {if (pass2 && (op1.konst > max8 || op1.konst<min8)) ende(241,3);
    aus_long(0xf5b00000+(op2.reg1<<16)+(op1.konst&0xff)+((i-1)<<8) );
    goto nextline;
   }

 ende(242,3);


/*************************************************************/
_trap:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr==53)             /* trap  #nr */
   {if (pass2 && op1.konst!=7 && op1.konst!=0x40) ende(243,3);
    if (op1.konst==7) aus_word(0xd673); else aus_word(0xd733);
    goto nextline;
   }

 ende(244,3);

/*************************************************************/
_tstl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr==2 && op2.nr==2)        /* tst.l   ri, rj  */
   {aus_word(0x0070+(op2.reg1<<9)+op1.reg1);
    goto nextline;
   }

ende(245,3);

/*************************************************************/





} /* end main */


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int out_byte(i) int i;
{char *p;

 putc(i,com);
 
 if (blk_flag)
    {print_string("\nACHTUNG: Code generiert nach blk-Anweisung in Zeile ");
     print_dec(line_nr);
     print_string("\nblk reserviert keinen Speicherplatz\n");
     blk_flag=0;
    }
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int aus_byte(i) int i;
{if (pass2) 
    {if (line_sp > 36) list_char(EOL);
     list_byte(i);
     list_char(' ');
     out_byte(i);
    }

 (*lab_wert)++;
 lab_wert[1]++;
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int aus_word(i) int i;

{if (pass2) 
    {if (line_sp > 34) list_char(EOL);
     list_byte(i>>8);
     list_byte(i);
     list_char(' ');
     out_byte(i>>8);
     out_byte(i);
    }

 (*lab_wert) += 2;
 lab_wert[1] += 2;
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int aus_long(i) long i;
{if (pass2) 
    {if (line_sp > 30) list_char(EOL);
     list_byte( (int)(i>>24) );
     list_byte( (int)(i>>16) );
     list_byte( (int)(i>>8) );
     list_byte( (int) i );
     list_char(' ');
     out_byte( (int)(i>>24) );
     out_byte( (int)(i>>16) );
     out_byte( (int)(i>>8) );
     out_byte( (int) i );
    }

 (*lab_wert) += 4;
 lab_wert[1] += 4;
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int list_byte(i) int i;
{int j;
 if (!line_sp)
    {
     line_sp=1;

     list_byte( (int)(lab_wert[1] >> 24));
     list_byte( (int)(lab_wert[1] >> 16));
     list_byte( (int)(lab_wert[1] >>  8));
     list_byte( (int)(lab_wert[1]      ));
     list_char(':');
     list_char(' ');

     list_byte( (int)( (*lab_wert) >> 24));
     list_byte( (int)( (*lab_wert) >> 16));
     list_byte( (int)( (*lab_wert) >>  8));
     list_byte( (int)( (*lab_wert)      ));
     list_char(':');
     list_char(' ');
     line_sp -= 1;
    }

 j = (i>>4)&15; 
 if (j<10) list_char(j+'0'); else  list_char(j-10+'a');

 j = i&15; 
 if (j<10) list_char(j+'0'); else  list_char(j-10+'a');
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int list_char(i) int i;
{if (list_level >= 0) {/* putc(i,stdout);*/ putc(i,lst);}
 if (i==EOL) line_sp = 0; else line_sp += 1;
}



/*************************************************************/
/* return 1:byte  2:word  3:long Operand                     */
/*************************************************************/

int get_wert(p,li) char *p; long *li;
{int i;
 if (i=get_w(p,li)) return (i);
 if (!pass2) {*li=0; return (1);}
 ende(246,10);
}

/*************************************************************/
/* return 0:Berechnung nicht meglich                         */
/*        1:byte  2:word  3:long Operand                     */
/*************************************************************/
#define max_tiefe 20

/*

hoechste Prioritaet
 ()             : Klammern
 !   ~   -      : logisches not, binaeres not, Minus-Vorzeichen
 *   /   \      : Multiplikation, Division, Rest (2er-Komplement-Darst.)
 +   -          : Addition, Subtraktion
 <<  >>         : Linksshift, Rechtsshift
 <   >   <=  >= : kleiner, groesser, kleiner-gleich, groesser-gleich
 ==  !=         : gleich, nicht gleich
 &              : binaeres AND
 ^              : binaeres XOR
 |              : binaeres OR
 &&             : logisches UND    (FALSE = 0;  TRUE=alles andere
 ||             : logisches ODER    TRUE als Ergebnis = 1)
niedrigste Prioritaet

Bei gleicher Prioritaet von links nach rechts ausser bei (! ~ -),
hier von rechts nach links.

!   : 0x00   (%000000 00)
~   : 0x01   (%000000 01)
-   : 0x02   (%000000 10)
*   : 0x04   (%000001 00)
/   : 0x05   (%000001 01)
\   : 0x06   (%000001 10)
+   : 0x08   (%000010 00)
-   : 0x09   (%000010 01)
<<  : 0x0c   (%000011 00)  
>>  : 0x0d   (%000011 01)
<   : 0x10   (%000100 00)
>   : 0x11   (%000100 01)
<=  : 0x12   (%000100 10)
>=  : 0x13   (%000100 11)
==  : 0x14   (%000101 00)
!=  : 0x15   (%000101 01)
&   : 0x18   (%000110 00)
^   : 0x1c   (%000111 00)
|   : 0x20   (%001000 00)
&&  : 0x24   (%001001 00)
||  : 0x28   (%001010 00)
NULL: 0x2c   (%001011 00)
(   : 0x30   (%001100 00)
)   : 0x31   (%001100 01)


*/

int get_w(p,li) char *p; long *li;
{int i=0,j=0,k;
 long la[max_tiefe+5];
 char ca[max_tiefe+5];

 ca[0]=0x34;

 while (1)
  {while (1)
    {if (i > max_tiefe || j > max_tiefe) ende(247,26);
     if (!*p) ende(248,11);
     if (*p == '(') {ca[++i]= 0x30; p++; continue;}
     if (*p == '!') {ca[++i]= 0x00; p++; continue;}
     if (*p == '~') {ca[++i]= 0x01; p++; continue;}
     if (*p == '-') {ca[++i]= 0x02; p++; continue;}

     if (*p == '$' || *p == '%' || *p == '"' || *p == '\'' || buchzahl(*p))
        {if (!get_zahl(&p,&la[++j])) return 0; break; }
     ende(249,12);
    }

   while (1) 
    {switch (*(p++))
        {case '*' : {k=0x04; break;}
         case '/' : {k=0x05; break;}
         case '\\': {k=0x06; break;}
         case '+' : {k=0x08; break;}
         case '-' : {k=0x09; break;}
         case '<' : {if (*p == '<') {k=0x0c; p++; break;}
                     if (*p == '=') {k=0x12; p++; break;}
                     k=0x10; break;}
         case '>' : {if (*p == '>') {k=0x0d; p++; break;}
                     if (*p == '=') {k=0x13; p++; break;}
                     k=0x11; break;}
         case '=' : {if (*p == '=') {k=0x14; p++; break;}
                     ende(250,14);}
         case '!' : {if (*p == '=') {k=0x15; p++; break;}
                     ende(251,14);}
         case '&' : {if (*p == '&') {k=0x24; p++; break;}
                     k=0x18; break;}
         case '^' : {k=0x1c; break;}
         case '|' : {if (*p == '|') {k=0x28; p++; break;}
                     k=0x20; break;}
         case ')' : {k=0x31; break;}
         case  0  : {k=0x2c; break;}
         default  : ende(252,14);
        }

     while ( (k|0x03) >= ca[i] )
        {if (j<1) ende(253,14); /*eigentlich unmoeglich*/
         switch(ca[i--])
            { case 0x00: {     la[j] = !la[j]          ; break;}
              case 0x01: {     la[j] = ~la[j]          ; break;}
              case 0x02: {     la[j] = -la[j]          ; break;}
              case 0x04: {j--; la[j] = la[j] *  la[j+1]; break;}
              case 0x05: {j--; la[j] = la[j] /  la[j+1]; break;}
              case 0x06: {j--; la[j] = la[j] %  la[j+1]; break;}
              case 0x08: {j--; la[j] = la[j] +  la[j+1]; break;}
              case 0x09: {j--; la[j] = la[j] -  la[j+1]; break;}
              case 0x0c: {j--; la[j] = la[j] << la[j+1]; break;}
              case 0x0d: {j--; la[j] = la[j] >> la[j+1]; break;}
              case 0x10: {j--; la[j] = la[j] <  la[j+1]; break;}
              case 0x11: {j--; la[j] = la[j] >  la[j+1]; break;}
              case 0x12: {j--; la[j] = la[j] <= la[j+1]; break;}
              case 0x13: {j--; la[j] = la[j] >= la[j+1]; break;}
              case 0x14: {j--; la[j] = la[j] == la[j+1]; break;}
              case 0x15: {j--; la[j] = la[j] != la[j+1]; break;}
              case 0x18: {j--; la[j] = la[j] &  la[j+1]; break;}
              case 0x1c: {j--; la[j] = la[j] ^  la[j+1]; break;}
              case 0x20: {j--; la[j] = la[j] |  la[j+1]; break;}
              case 0x24: {j--; la[j] = la[j] && la[j+1]; break;}
              case 0x28: {j--; la[j] = la[j] || la[j+1]; break;}
              case 0x30: goto weiter;
              default: ende(254,14);
            }
        }
     if (k==0x2c) goto fertig;
     ca[++i] = k;
     break;
weiter:;
    }
  }

fertig:
 if (i || --j) ende(255,14);
 *li=la[1];
 if ( !(*li & ~high8)  || !(~*li & min8) ) return 1;
 if ( !(*li & ~high16) || !(~*li & min16)) return 2;
 return 3;
}


/*************************************************************/
/* Rueckgabewert  0: Zahl konnte nicht berechnet werden      */
/*                1: Zahl konnte berechnet werden            */
/*************************************************************/

int get_zahl(pp,lip)  char **pp; long *lip;
{char *q;
 int i,j;

 q = *pp;
 *lip = 0;

 if (*q>='0' && *q<='9') 
    {while (*q >= '0' && *q <= '9') *lip = 10 * (*lip) + *q++ -'0';
     *pp = q;
     return 1;}

 if (*q=='%') 
    {q++;
     while (*q == '0' || *q == '1') *lip = 2 * (*lip) + *q++ -'0';
     *pp = q;
     return 1;}

 if (*q=='$')
    {q++;
     while ( (i='0', *q >= '0' && *q <= '9') || 
             (i='a'-10, *q >= 'a' && *q <= 'f')    )
     *lip = 16 * (*lip) + *q++ -i;
     *pp = q;
     return 1;}

 if ( (i = *q) == '\'' || i == '"')
    {q++;
     for (j=1; j<=4; j++)
         {if (! *q ) {*pp = q; return 1;}
          if (*q == i) {*pp = q+1; return 1;}
          *lip = (*lip << 8) + *q++;
         }
     if (*q == i) {*pp = q+1; return 1;}
     ende(256,22);
    }

 if (buchst(*q))
    { while (buchzahl(*++q));
      i = *q;
      *q = 0;
      if (get_lab(*pp,lip)) {*q = i; *pp = q; return 1;}
      *q = i;
    }
 return 0;
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int get_operand(p) char *p;
{int ch,i=0,j=0;

 while ((ch=read_char()) == ' ');
 if (ch==EOL) {p[0]=0; return;}
 while ( (p[i++]=ch) != EOL ) ch=read_char();
 p[--i]=0;
 del_blank(p);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int del_blank(p) char *p;
{char *q,*p1;
 int ch=0, l_ch, l_bz;
 int instring=0;

 q=p;
 while (l_ch=ch, ch = *q++ = *p++)
   {if (l_ch!=' ') l_bz=buchzahl(l_ch);
    if (ch==instring) {instring=0; continue;}
    if (instring)  continue;
    if (ch=='\'' || ch=='"') {instring=ch; continue;}
    if (ch==' ') q--;
    if ( !(l_ch==' ' && buchzahl(ch) && l_bz) ) continue;
    p1=p; while(*++p1 == ' ');
    if (ch!='.' || *p!='b' && *p!='w'  && *p!='l' 
                || *p1!=0  && *p1!='(' && *p1!='{'     ) ende(257,17);
   }
 *q++ = 0;
}
      



/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int dec_operand1(dir,p,op) int dir; char *p; op_typ *op;

{int i,j,k,n;
 int par[5];
 char *r;

 if (!*p) ende(258,3);

 if ( finds ( p , "{user}" , par, &r) )
     {op->nr=9; *r=0;}
 else if ( finds ( p , "{cp?}" , par, &r) )
     {if (par[0]>7) ende(259,3);
      op->nr=par[0]; *r=0;}
 else op->nr=8;

 i=15*dir; j=0; k=0;
 while ( finds ( p , "r?" , par, &r) )
  {if ( par[0]>15 || (!dir && par[0]<i) || (dir && par[0]>i) ) ende(260,20); 
   *r=0;
    
   if (k==0) i=par[0];
   if (!dir) for (; i<=par[0]; i++) j=j+(1<<i);
   else      for (; i>=par[0]; i--) j=j+(1<<i);
   if (r==p) break;
   if (*(--r) == '/') {*r=0; k=0; continue;}
   if (*r != '-' || k) ende(261,12);
   *r=0; k=1;
  }    

 if (*p || !j) ende(262,12);


 op->reg1=j;


 if ( (j&0xaa) == ((j&0x55)<<1) )
   op->konst= ((j&0x4000)>>7) +((j&0x1000)>>6) +((j&0x0400)>>5) +((j&0x0100)>>4)
              +((j&0x0040)>>3) +((j&0x0010)>>2) +((j&0x0004)>>1) +((j&0x0001)   ); 
   else op->konst=0;



  if ( (j&0x2000) || ( (j&0x300)!=0x000 && (j&0x300)!=0x300 )
                 || ( (j&0x0f0)!=0x000 && (j&0x0f0)!=0x0f0 ) 
                 || ( (j&0x00f)!=0x000 && (j&0x00f)!=0x00f ))  {op->reg2=0; return;}

 op->reg2=  ((j&0x8000)>>8) + ((j&0x4000)>>8) + ((j&0x1000)>>7) + ((j&0x0800)>>7) 
          + ((j&0x0400)>>7) + ((j&0x0200)>>7) + ((j&0x0010)>> 3) + ((j&0x0001)    );

 return;
}



/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int dec_operand(p,op) char *p; op_typ *op;

{int i;
 int par[5];
 char *r;

 if (!*p) {op->nr=1; return;}

 if ( finds ( p , "r?" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=2;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "r?{cp?}" , par, &r) )
    {if (r==p && par[0]<8 && par[1]<16)
     {op->nr=3;
      op->reg1=par[1];
      op->konst=par[0];
      return;
     }
    }

 if ( finds3 ( p , "r?{debug}" , par, &r) )
    {if (r==p && par[0]<256)
     {op->nr=4;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds3 ( p , "r?{system}" , par, &r) )
    {if (r==p && par[0]<256)
     {op->nr=5;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "r?|r?" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=6;
      op->reg1=par[1];
      op->reg2=par[0];
      return;
     }
    }

 if ( finds ( p , "r?|r?{cp?}" , par, &r) )
    {if (r==p && par[0]<8 && par[1]<16 && par[2]<16)
     {op->nr=7;
      op->reg1=par[2];
      op->reg2=par[1];
      op->konst=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[15:0]|r?[31:16]" , par, &r) )
    {if (r==p && par[0]<16 && par[1]==par[0])
     {op->nr=8;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[31:16]|r?[31:16]" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=9;
      op->reg1=par[1];
      op->reg2=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[31:16]|r?[15:0]" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=10;
      op->reg1=par[1];
      op->reg2=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[15:0]|r?[31:16]" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=11;
      op->reg1=par[1];
      op->reg2=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[15:0]|r?[15:0]" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=12;
      op->reg1=par[1];
      op->reg2=par[0];
      return;
     }
    }


 if ( finds ( p , "|r?|" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=26;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "~r?" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=27;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "r?*?" , par, &r) )
    {if (r==p && par[1]<16)
     {op->nr=28;
      op->reg1=par[1];
      if (par[0]==1) {op->konst=0; return;}
      if (par[0]==2) {op->konst=1; return;}
      if (par[0]==4) {op->konst=2; return;}
      if (par[0]==8) {op->konst=3; return;}
     }
    }

if ( cmps ( p , "sp")) {op->nr=29; return;}

if ( cmps ( p , "sp{java}")) {op->nr=30; return;}

 if ( finds ( p , "r?[31:16]" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=31;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[15:8]" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=32;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[23:16]" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=33;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[31:24]" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=34;
      op->reg1=par[0];
      return;
     }
    }

 op->nr=35;
 if (p[0]=='r' && p[3]=='<')
    {if (p[2]=='<' && p[1]>='0' && p[1]<='9') 
        {op->reg1=p[1]-'0'; get_wert(p+4,&op->konst);
         if ( (unsigned long) op->konst < 32) return;
        }

     if (p[4]=='<' && (  (p[1]=='0' && p[2]>='0' && p[2]<='9')
                       ||(p[1]=='1' && p[2]>='0' && p[2]<='5')))
        {op->reg1=(p[1]-'0')*10 + p[2]-'0'; get_wert(p+5,&op->konst);
         if ( (unsigned long) op->konst < 32) return;
        }
    }


 op->nr=36;
 if (p[0]=='r' && p[3]=='>')
    {if (p[2]=='>' && p[1]>='0' && p[1]<='9') 
        {op->reg1=p[1]-'0'; get_wert(p+4,&op->konst);
         if ( (unsigned long) op->konst < 32) return;
        }

     if (p[4]=='>' && (  (p[1]=='0' && p[2]>='0' && p[2]<='9')
                       ||(p[1]=='1' && p[2]>='0' && p[2]<='5')))
        {op->reg1=(p[1]-'0')*10 + p[2]-'0'; get_wert(p+5,&op->konst);
         if ( (unsigned long) op->konst < 32) return;
        }
    }

 if ( finds ( p , "-(r?)" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=37;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "(r?)+" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=38;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "(r?,r?)" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=39;
      op->reg1=par[1];
      op->reg2=par[0];
      op->konst=0;
      return;
     }
    }

 if ( finds ( p , "(r?,r?*?)" , par, &r) )
    {if (r==p && par[1]<16 && par[2]<16)
     {op->nr=39;
      op->reg1=par[2];
      op->reg2=par[1];
      if (par[0]==1) {op->konst=0; return;}
      if (par[0]==2) {op->konst=1; return;}
      if (par[0]==4) {op->konst=2; return;}
      if (par[0]==8) {op->konst=3; return;}
     }
    }

 if ( finds ( p , "(r?,r?[7:0]*4)" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=40;
      op->reg1=par[1];
      op->reg2=par[0];
      return;
     }
    }


  if ( finds ( p , "(r?,r?[15:8]*4)" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=41;
      op->reg1=par[1];
      op->reg2=par[0];
      return;
     }
    }


  if ( finds ( p , "(r?,r?[23:16]*4)" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=42;
      op->reg1=par[1];
      op->reg2=par[0];
      return;
     }
    }


  if ( finds ( p , "(r?,r?[31:24]*4)" , par, &r) )
    {if (r==p && par[0]<16 && par[1]<16)
     {op->nr=43;
      op->reg1=par[1];
      op->reg2=par[0];
      return;
     }
    }

 if ( finds ( p , ".b(r?)" , par, &r) )
    {if (par[0]<16)
     {op->nr=44;
      op->reg1=par[0];
      op->reg2=1;
      *r=0;
      get_wert(p,&op->konst);
      return;
     }
    }

 if ( finds ( p , "(r?)" , par, &r) )
    {if (par[0]<16)
     {op->nr=44;
      op->reg1=par[0];
      if (r==p) {op->reg2=0; op->konst=0; return;}
      op->reg2=2;
      *r=0;
      get_wert(p,&op->konst);
      return;
     }
    }

 if ( finds ( p , "(pc)" , par, &r) )
    {op->nr=45;
     *r=0;
     get_wert(p,&op->konst);
     return;
    }

 if ( finds ( p , "(sp)" , par, &r) )
    {op->nr=451;
     *r=0;
     get_wert(p,&op->konst);
     return;
    }



 if ( finds ( p , "leadingzeros{r?}" , par, &r) )
    {if (r==p && par[0]<16)
     {op->nr=47;
      op->reg1=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[?]" , par, &r) )
    {if (r==p && par[0]<32 && par[1]<16)
     {op->nr=48;
      op->reg1=par[1];
      op->konst=par[0];
      return;
     }
    }

 if ( finds ( p , "r?[?:?]" , par, &r) )
    {if (r==p && par[0]<32 && par[1]<32 && par[0]<=par[1] && par[2]<16)
     {op->nr=49;
      op->reg1=par[2];
      op->reg2=par[1];
      op->konst=par[0];
      return;
     }
    }

 if ( finds ( p , "sr[?]" , par, &r) )
    {if (r==p && par[0]<32)
     {op->nr=50;
      op->konst=par[0];
      return;
     }
    }

if ( cmps ( p , "sr[3:0]")) {op->nr=51; return;}
if ( cmps ( p , "sr[cz]")) {op->nr=52; return;}
if ( cmps ( p , "sr[c]")) {op->nr=521; return;}

 if (p[0]=='#')
    {p++;
     op->nr=53;
     op->reg1 = get_wert(p,&op->konst);
     return;
    }

 if ( finds ( p , "[?]" , par, &r) )
    {if (par[0]<32)
     {op->nr=46;
      op->reg1=par[0];
      if (r==p) ende(263,2);
      *r=0;
      get_wert(p,&op->konst);
      return;
     }
    }


 ende(264,16);
}


/*************************************************************/
/* Rueckgabewert  0:nicht gefunden  1: gefunden              */
/*************************************************************/


int finds(p,q,pi,r) char *p,*q; int *pi; char **r;
{int i=0, j=0;

 while (*p) {j++; p++;} --p;
 while (*q) {i++; q++;} --q;

 if (j<i) return 0;
 j=j-i+1;

 while (i--)
  {if ( *q != '?') if (*p-- == *q--) continue; else return 0;
   if ( *p < '0' || *p > '9') return 0;
   *pi++ = *p-- - '0'; q--; 
   if ( *p < '0' || *p > '9') continue;
   *(pi-1) = *(pi-1) + 10 * (*p-- - '0'); if (!(j--)) return 0;
  }
 *r=p+1;
 return 1;
}

/*************************************************************/
/* Rueckgabewert  0:nicht gefunden  1: gefunden              */
/*************************************************************/

int finds3(p,q,pi,r) char *p,*q; int *pi; char **r;
{int i=0, j=0;

 while (*p) {j++; p++;} --p;
 while (*q) {i++; q++;} --q;

 if (j<i) return 0;
 j=j-i+1;

 while (i--)
  {if ( *q != '?') if (*p-- == *q--) continue; else return 0;
   if ( *p < '0' || *p > '9') return 0;
   *pi++ = *p-- - '0'; q--; 
   if ( *p < '0' || *p > '9') continue;
   *(pi-1) = *(pi-1) + 10 * (*p-- - '0'); if (!(j--)) return 0;
   if ( *p < '0' || *p > '9') continue;
   *(pi-1) = *(pi-1) + 10 * (*p-- - '0'); if (!(j--)) return 0;
  }
 *r=p+1;
 return 1;
}


/*************************************************************/
/* Rueckgabewert  0:nicht gleich  1: gleich                  */
/*************************************************************/

int cmps(p,q) char *p,*q;
{while (*p && *p==*q) p++,q++;
 return *p?0:!*q;
}


/*************************************************************/
/* Rueckgabewert  0:nicht gleich  1+cc: gleich                */
/*************************************************************/

int cmps_cc(p,q) char *p,*q;
{int n=0;
 while (*p && *p==*q) p++,q++;
 if (*q == '?')
   {if      (*p == 'e' && *(p+1) == 'q') n=1;
    else if (*p == 'n' && *(p+1) == 'e') n=2;
    else if (*p == 'c' && *(p+1) == 'c') n=3;
    else if (*p == 'h' && *(p+1) == 's') n=3;
    else if (*p == 'c' && *(p+1) == 's') n=4;
    else if (*p == 'l' && *(p+1) == 'o') n=4;
    else if (*p == 'g' && *(p+1) == 'e') n=5;
    else if (*p == 'l' && *(p+1) == 't') n=6;
    else if (*p == 'm' && *(p+1) == 'i') n=7;
    else if (*p == 'p' && *(p+1) == 'l') n=8;
    else if (*p == 'l' && *(p+1) == 's') n=9;
    else if (*p == 'g' && *(p+1) == 't') n=10;
    else if (*p == 'l' && *(p+1) == 'e') n=11;
    else if (*p == 'h' && *(p+1) == 'i') n=12;
    else if (*p == 'v' && *(p+1) == 's') n=13;
    else if (*p == 'v' && *(p+1) == 'c') n=14;
    else if (*p == 'q' && *(p+1) == 's') n=15;
    else if (*p == 't' && *(p+1) == 'r') n=16;
    else return 0;
    p+=2; q++;
   }
 while (*p && *p==*q) p++,q++;
 return *p?0:(!*q)*n;
}

/*************************************************************/
/* Rueckgabewert  0: kein Opcode  1:Opcode gefunden          */
/*************************************************************/

int get_opcode(p) char *p;
{int ch,i;
 char *q;

 op_pref=0;

 while (1)
  {q=p; q[0]=0;
   while ( (ch=read_char()) == ' ');
   if (last_ch==EOF) return 0;
   if (ch==EOL) return 1;
   if (!buchst(ch)) ende(265,12);
   while (*q++=ch, buchzahl(ch=read_char()));

   if (ch == ' ') 
      {while (next_ch == ' ') ch = read_char();
       if (next_ch == ':' || next_ch == '=') ch = read_char();
      }

   if (ch=='=') 
      {while (next_ch == ' ') read_char();
       *q++ = *p; *q = 0;
       if (next_ch == '=') {read_char();  *p = ':'; return 1;}
          else                          { *p = '='; return 1;}
      }

   *q=0;
   if (ch==EOL) return 1;
   if (ch==' ') return 1;
   if (ch!=':') ende(266,12);

   while (next_ch == ' ') read_char();
   if (next_ch == ':')  {read_char(); i=3;} else i=2;
   if (if_wert<0) continue;
   if (p[0]=='_') i=1;  
   ins_lab(p,*lab_wert,i);
  }
}

/*************************************************************/
/* Rueckgabewert  Nummer des Labels  -1 falls nicht vorhanden*/
/*************************************************************/

int find_lab(p) char *p;
{int i,j;

 if (*p == '_')
    {i=lab_lokal-1;
     do         /*10.2.94*/
      {i++; 
       while ( (j=abs(lab_guelt[i])) ==1) if (cmps(lab_pa[i++],p)) return i-1;
      } 
     while ( j==4 || (j && (*lab_pa[i]=='.')) );
     return -1;
    }

 i=lab_block;
 while (lab_guelt[i]!=0) 
       {if (abs(lab_guelt[i])==2 && cmps(lab_pa[i],p)) return i;
        i++;
       }

 i=0;
 while (i<=lab_last)
       {if (   (abs(lab_guelt[i])==3 || lab_guelt[i]==4)
            && cmps(lab_pa[i],p)) return i;
        i++;
       }

 return -1;

}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int ins_lab(p,wert,g) char *p; long wert; int g;
{char *q;
 int i=0;

 q=p;
 while (*q++) if (*q == '.') ende(267,18); /*10.2.94*/

 if (*p == '@') if (g<0 ) ende(268,10); else g=4; 

 if ( (i=find_lab(p)) >= 0)
    {if (!pass2 && g != 4 ) ende(269,19); 
     lab_wert[i]=wert; lab_guelt[i]=g;
     if (*p != '_' && *p != '.' && *p !='@') lab_lokal=i+1; /*10.2.94*/
    }
 else
    {q=lab_pa[(i = ++lab_last)];
     if (*p != '_' && *p != '.' && *p !='@') lab_lokal=i+1; /*10.2.94*/
     if ( q > (lab_buf + maxbuf) ) ende(270,23);
     while (*q++ = *p++);
     if (lab_last > maxlabel) ende(271,24);
     lab_wert[i]=wert;
     lab_guelt[i]=g;
     lab_pa[i+1]=q;
     lab_guelt[i+1]=0;
    }
}


/*************************************************************/
/* return 0:ungueltiger  1:gueltiger  Labelwert              */
/*************************************************************/

int get_lab(p,wert) char *p; long *wert;
{int i=0;

 if ( (i=find_lab(p)) >= 0) 
    {*wert=lab_wert[i];
     if (lab_guelt[i]>0) return 1;
    }
 return 0;

}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int list_label()
{int i,j;
 long li;
 char *p;

 list_char(EOL);
 line_sp=110;

 for (i=0; i <= lab_last; i++) 
   {p = lab_pa[i];
    if ( lab_guelt[i] > 1 && *p != '@')
       {if (line_sp > 64) list_char(EOL);
           else for (j=0; j<3; j++) list_char(' ');
        j=0;
        while (*p) {list_char(*p++); j++;}
        while (j < 15) {list_char('.'); j++;}
        list_char(' ');
        li = lab_wert[i];
        list_byte( (int)(li>>24) );
        list_byte( (int)(li>>16) );
        list_byte( (int)(li>>8) );
        list_byte( (int) li );
       }
   }
}
 

/*************************************************************/
/* Rueckgabewert  0:kein Buchstabe  1:Buchstabe              */
/*************************************************************/

int buchst(ch) char ch;
{if (ch=='.' || ch=='_' || ch=='@') return 1;
 if (ch >= 'a' && ch <= 'z' )  return 1;
 return 0;
}


/*************************************************************/
/* Rueckgabewert  0:kein Buchstabe/Zahl  1:Buchstabe/Zahl    */
/*************************************************************/

int buchzahl(ch) char ch;
{
 return (buchst(ch) || ( ch>='0' && ch<='9' ) );
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int skip_line()
{while (last_ch != EOL && last_ch != EOF) read_char();
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int read_eol()
{int i;
 if (last_ch != EOL && last_ch != EOF) 
    {while (read_char() == ' ');
     if (last_ch != EOL && last_ch != EOF) ende(272,20);
    }
 if (last_ch == EOL) last_ch=0;

 if (pass2) 
    {while (line_sp < 40) list_char(' ');
     for (i=0;i<l_line_lang;i++) list_char(last_line[i]);
     l_line_lang=0;
    }

 line_nr++;
 return;
}


/*************************************************************/
/* Rueckgabewert gelesenes Zeichen                           */
/*************************************************************/

int read_char()
{int ch;
 static int instring = 0;

 if ( (ch=get_char()) == ';' && !instring) 
    { while ( (ch=get_char()) != EOL );
      return (ch);
    }

 if (ch == instring) {instring=0; return (ch);}
 if (instring==')') goto abc;
 if (instring) return(ch);
 if (ch == '\'' || ch == '"') {instring=ch; return(ch);}
 if (ch == '(' ) {instring=')'; return (ch);} /* kein Ende bei , */
 if (ch ==',') return (EOL);
abc:
 if (ch >= 'A' && ch <= 'Z') ch+='a'-'A';

 return (ch);

}


/*************************************************************/
/* Rueckgabewert gelesenes Zeichen                           */
/*************************************************************/

int get_char()
{if (last_ch==EOL || last_ch==EOF) return EOL;
 last_ch = next_ch;
 next_ch = getc(mac);
 if ( last_ch  == EOF ) return (EOL);
 if (last_ch==TAB) last_ch=' ';
 if (last_ch==CR) if (next_ch==EOL) last_ch=' '; else last_ch=EOL;
 
if (pass2) 
    { if (l_line_lang >= max_line_lang) ende(273,21);
      last_line[l_line_lang++]=last_ch; 
    }
/*    else putc(last_ch,stdout);
*/

 return (last_ch);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/
int ende(j,i) int j,i;

{char *p;
 static char *(meld[]) = {

/*  0 */ "Normales Ende" ,
/*  1 */ "Unbekannter Opcode" ,
/*  2 */ "Sorry, currently no error messages available" ,
/*  3 */ "Ungueltiger Operand fuer diesen Befehl" ,
/*  4 */ "Sorry, currently no error messages available" ,
/*  5 */ "Sorry, currently no error messages available" ,
/*  6 */ "Sorry, currently no error messages available" ,
/*  7 */ "Sorry, currently no error messages available" ,
/*  8 */ "Sorry, currently no error messages available" ,
/*  9 */ "Sorry, currently no error messages available" ,
/* 10 */ "Label nicht gefunden" ,
/* 11 */ "Kein Wert" ,
/* 12 */ "Ungueltiges Zeichen" ,
/* 13 */ "Ungueltige Klammer" ,
/* 14 */ "Ungueltiger Ausdruck" ,
/* 15 */ "Sorry, currently no error messages available" ,
/* 16 */ "Ungueltiger Operand" ,
/* 17 */ "Ungueltiges Leerzeichen" ,
/* 18 */ "Punkt im Label" ,
/* 19 */ "Label doppelt definiert" ,
/* 20 */ "Zu viele Operanden" ,
/* 21 */ "Zu lange Eingabezeile" ,
/* 22 */ "Zu lange ASCII-Konstante" ,
/* 23 */ "Labelpuffer voll" ,
/* 24 */ "Pointer-Array fuer Label voll" ,
/* 25 */ "Ungueltige ASCII-Konstante" ,
/* 26 */ "Zu viele Klammern" ,
/* 27 */ "Felendes ENDIF" ,
/* 28 */ "Zu viele IF's" ,
/* 29 */ "Zu viele ELSE's" , 
/* 30 */ "Zu viele ENDIF's", 
/* 31 */ "Quelltextdatei konnte nicht geoeffnet werden", 
/* 32 */ "Listdatei konnte nicht geoeffnet werden" ,
/* 33 */ "COM-Datei konnte nicht geoeffnet werden" 

};
 print_string("\n\n");
 print_dec(j);
 print_string(" : ");
 print_string(meld[i]);
 print_string(" in Zeile "); 
 print_dec(line_nr);
 print_string("\n"); 
 
 if (mac!=NULL) fclose(mac);
 if (pass2) {if (lst!=NULL) fclose(lst); 
             if (com!=NULL) fclose(com);}
 exit(0);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/
int print_dec(i) int i;
{int k,j=1;
 if (i<0) {putc('-',stdout); i = -i;}
 k=i;
 while (k /= 10) j *= 10;
 while (j)
     {k=i/j;
      putc(k+'0',stdout);
      i -= k*j;
      j /= 10;
     }
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/
int print_string(p) char *p;

{while (*p) putc(*p++,stdout);
}


